#pragma warning(disable:4115)
#include <windows.h>
#include <stdlib.h>

/*
 *	  ⥪⮢    ப묨 ﬨ.
 */


/*	======================================================================
 *	ࢨ 㭪樨 - ࠡ  ⥪.
 *	 룫廊 ⪮ -  뤥  㣮  ஥.
 */

typedef unsigned char	u8_t, *u8_p;
typedef void			*void_p, **void_pp;
#define memCopy				memcpy
#define memZero(blk,len)	memset(blk,0,len)
#define	memAlloc			malloc
#define	memFree				free
#define	memRealloc			realloc
#define	V_ASSERT(value)		/* Nothing to do :) */

/*
 *	Handy macros for making powers of 2.
 */

/*		Returns 1 if value is power of 2; otherwise returns 0 */
#define IS_POWER_TWO(x)			(((x) & ((x)-1)) ? 0 : 1)

/*
 * Aligns u32_t 'src', so:
 *	a) dst>=src;
 *	b) least 'zero_bits' in 'dst' set to zero.
 * For expample, if 'zero_bits' is 2: 0->0; {1,2,3,4}->4; etc.
 * 'dst' and 'src' can be the same.
 */

#define	ALIGN_UP(dst,src,zero_bits) { \
		u32_t set_bits=(1<<(zero_bits))-1; \
		(dst)=((src)+set_bits)&(0xFFFFFFFF-set_bits); }

/*		Based on Quake's net_loop.c::IntAlign */
#define	INT_ALIGN(value) \
		(((value) + (sizeof(int) - 1)) & (~(sizeof(int) - 1)))

/*		Sets retval to power of 2 which is not less than value */
/*		TODO: There are better ways to do it ... */
#define	NOT_LESS_POWER_TWO(retval,value,type)\
		{\
			type mask;\
			if((value)==(type)0) {\
				retval=0;\
			} else {\
				mask=(type)1 << ((sizeof(type)<<3)-1);\
				while(!(mask & (value)))\
					mask>>=1;\
				retval = (mask < (value)) ? mask << 1 : mask;\
			}\
		}

/*		Sets retval to power of 2 which is greater than value */
/*		TODO: There are better ways to do it ... */
#define	GREATER_POWER_TWO(retval,value,type)\
		{\
			type mask;\
			if((value)==(type)0) {\
				retval=1;\
			} else {\
				mask=(type)1 << ((sizeof(type)<<3)-1);\
				while(!(mask & (value)))\
					mask>>=1;\
				retval = (mask <= (value)) ? mask << 1 : mask;\
			}\
		}


#define	TYPED_STACK_DEFINE_CLASS(type_prefix,type) \
typedef struct type_prefix##_stack_s \
{ \
	unsigned	n_elem;			/* maximal number of elements */ \
	unsigned	next_elem;		/* number of added elements */ \
	type		*buf;			/* stack's storage */ \
}	type_prefix##_stack_t, *type_prefix##_stack_p;

#define	TYPED_STACK_EMPTY_INITIALIZER {0,0,NULL}

TYPED_STACK_DEFINE_CLASS(u8,u8_t)
TYPED_STACK_DEFINE_CLASS(vp,void_p)
TYPED_STACK_DEFINE_CLASS(u,unsigned)

#define	TYPED_STACK_INIT(stack)\
		(stack).n_elem=(stack).next_elem=0;\
		(stack).buf=NULL;

#define	TYPED_STACK_PUSH(stack,element,type_elem)\
		if((stack).next_elem>=(stack).n_elem) {\
			/* Allocate new storage */\
			unsigned nextsize;\
			GREATER_POWER_TWO(nextsize,(stack).next_elem,unsigned);\
			(stack).buf=(type_elem*)realloc((stack).buf,nextsize*sizeof(type_elem));\
			(stack).n_elem=nextsize;\
		}\
		(stack).buf[(stack).next_elem++]=element;

#define	TYPED_STACK_PUSH_BUFFER(stack,buffer,num_elements,type_elem)\
		{\
			unsigned total;\
			total=(stack).next_elem+(num_elements);\
			if(total > (stack).n_elem) {\
				NOT_LESS_POWER_TWO(total,total,unsigned);\
				(stack).buf=(type_elem*)realloc((stack).buf,total*sizeof(type_elem));\
				(stack).n_elem=total;\
			}\
			memCopy((stack).buf+(stack).next_elem,(buffer),\
				(num_elements)*sizeof(type_elem));\
			(stack).next_elem+=(num_elements);\
		}

#define	TYPED_STACK_RESIZE(stack,newsize,type_elem)\
		if((newsize) > (stack).n_elem) {\
			/* We must allocate new storage */\
			unsigned nextlen;\
			NOT_LESS_POWER_TWO(nextlen,(newsize),unsigned);\
			(stack).buf=(type_elem*)realloc((stack).buf,nextlen*sizeof(type_elem));\
			/* Fill rest with zeros */\
			memZero((stack).buf+(stack).next_elem,\
				((newsize)-(stack).next_elem)*sizeof(type_elem));\
			(stack).n_elem=nextlen;\
		} else {\
			/* We fit in current storage */\
			if((newsize) > (stack).next_elem)\
				memZero((stack).buf+(stack).next_elem,\
					((newsize)-(stack).next_elem)*sizeof(type_elem));\
		}\
		(stack).next_elem=(newsize);\

/*	Function's templates for "typed stacks"
 */
#define	TYPED_STACK_DEFINE_INIT(type_prefix)\
void	\
type_prefix##sInit(type_prefix##_stack_t *stack)\
{\
	V_ASSERT(stack);\
	TYPED_STACK_INIT(*stack);\
}

#define	TYPED_STACK_DEFINE_CLEAR(type_prefix)\
void	\
type_prefix##sClear(type_prefix##_stack_t *stack)\
{\
	V_ASSERT(stack);\
	if(stack->buf)\
		free(stack->buf);\
	TYPED_STACK_INIT(*stack);\
}

#define	TYPED_STACK_DEFINE_PUSH(type_prefix,type)\
void	\
type_prefix##sPush(type_prefix##_stack_t *stack,type element)\
{\
	V_ASSERT(stack);\
	TYPED_STACK_PUSH(*stack,element,type);\
}

#define	TYPED_STACK_DEFINE_POP(type_prefix,type)\
int		\
type_prefix##sPop(type_prefix##_stack_t *stack,type *element)\
{\
	V_ASSERT(stack && element);\
	if(stack->next_elem) {\
		*element=stack->buf[--stack->next_elem];\
		return 1;\
	} else return 0;\
}

#define	TYPED_STACK_DEFINE_PUSH_BUFFER(type_prefix,type)\
void	\
type_prefix##sPushBuffer(type_prefix##_stack_t *stack,\
						type *src,unsigned num_elements)\
{\
	V_ASSERT(stack && src && num_elements);\
	TYPED_STACK_PUSH_BUFFER(*stack,src,num_elements,type);\
}

#define	TYPED_STACK_DEFINE_POP_BUFFER(type_prefix,type)\
int		\
type_prefix##sPopBuffer(type_prefix##_stack_t *stack,\
						type *dst,unsigned num_elements)\
{\
	V_ASSERT(stack && dst && num_elements);\
	if(num_elements>stack->next_elem)\
		num_elements=stack->next_elem;\
	stack->next_elem-=num_elements;\
	memCopy(dst,stack->buf + stack->next_elem,num_elements*sizeof(type));\
	return num_elements;\
}

#define	TYPED_STACK_DEFINE_RESIZE(type_prefix,type)\
void	\
type_prefix##sResize(type_prefix##_stack_t *stack,unsigned newsize)\
{\
	V_ASSERT(stack && newsize>=0);\
	TYPED_STACK_RESIZE(*stack,newsize,type);\
}

#define	TYPED_STACK_DEFINE_COUNT(type_prefix)\
unsigned	\
type_prefix##sCount(type_prefix##_stack_t *stack)\
{\
	V_ASSERT(stack);\
	return stack->next_elem;\
}

#define	TYPED_STACK_DEFINE_GET(type_prefix,type)\
type	\
type_prefix##sGet(type_prefix##_stack_t *stack,unsigned pos)\
{\
	V_ASSERT(stack && stack->n_elem > pos);\
	return stack->buf[pos];\
}

#define	TYPED_STACK_DEFINE_GET_STORAGE(type_prefix,type_ptr)\
type_ptr	\
type_prefix##sGetStorage(type_prefix##_stack_t *stack)\
{\
	V_ASSERT(stack);\
	return stack->buf;\
}

#define	TYPED_STACK_DEFINE_SET(type_prefix,type)\
void	\
type_prefix##sSet(type_prefix##_stack_t *stack,unsigned pos,type element)\
{\
	V_ASSERT(stack && pos>=0);\
	if(pos>=stack->n_elem)\
	{\
		TYPED_STACK_RESIZE(*stack,pos+1,type);\
	}\
	stack->buf[pos]=element;\
}

#define	TYPED_STACK_DEFINE_CONCAT(type_prefix,type)\
void	\
type_prefix##sConcat(type_prefix##_stack_t *dst,type_prefix##_stack_t *src)\
{\
	V_ASSERT(src && dst);\
	TYPED_STACK_PUSH_BUFFER(*dst,src->buf,src->next_elem,type);\
}

	TYPED_STACK_DEFINE_INIT(u8)
	TYPED_STACK_DEFINE_CLEAR(u8)
	TYPED_STACK_DEFINE_PUSH(u8,u8_t)
	TYPED_STACK_DEFINE_PUSH_BUFFER(u8,u8_t)
	TYPED_STACK_DEFINE_POP(u8,u8_t)
	TYPED_STACK_DEFINE_POP_BUFFER(u8,u8_t)
	TYPED_STACK_DEFINE_RESIZE(u8,u8_t)
	TYPED_STACK_DEFINE_CONCAT(u8,u8_t)
	TYPED_STACK_DEFINE_SET(u8,u8_t)

	TYPED_STACK_DEFINE_INIT(vp)
	TYPED_STACK_DEFINE_CLEAR(vp)
	TYPED_STACK_DEFINE_PUSH(vp,void_p)
	TYPED_STACK_DEFINE_PUSH_BUFFER(vp,void_p)
	TYPED_STACK_DEFINE_POP(vp,void_p)
	TYPED_STACK_DEFINE_POP_BUFFER(vp,void_p)
	TYPED_STACK_DEFINE_RESIZE(vp,void_p)
	TYPED_STACK_DEFINE_CONCAT(vp,void_p)
	TYPED_STACK_DEFINE_SET(vp,void_p)

	TYPED_STACK_DEFINE_INIT(u)
	TYPED_STACK_DEFINE_CLEAR(u)
	TYPED_STACK_DEFINE_PUSH(u,unsigned)
	TYPED_STACK_DEFINE_PUSH_BUFFER(u,unsigned)
	TYPED_STACK_DEFINE_POP(u,unsigned)
	TYPED_STACK_DEFINE_POP_BUFFER(u,unsigned)
	TYPED_STACK_DEFINE_RESIZE(u,unsigned)
	TYPED_STACK_DEFINE_CONCAT(u,unsigned)
	TYPED_STACK_DEFINE_SET(u,unsigned)

#define	u8sCount(stack)		((stack)->next_elem)
#define	vpsCount(stack)		((stack)->next_elem)
#define	usCount(stack)		((stack)->next_elem)

#define u8sGet(stack,pos)	((stack)->buf[(pos)])
#define vpsGet(stack,pos)	((stack)->buf[(pos)])
#define usGet(stack,pos)	((stack)->buf[(pos)])

#define u8sGetStorage(stack)	((stack)->buf)
#define vpsGetStorage(stack)	((stack)->buf)
#define usGetStorage(stack)		((stack)->buf)

/*
 *	 ⮡ࠦ
 */ 
typedef struct mmap_s
{
	HANDLE	fd;
	HANDLE	md;
	size_t	len;
	void	*base;
}	mmap_t, *mmap_p;

mmap_p
mmapOpenRead(char *nt_file_name)
{
	DWORD type,size;
	HANDLE fd, md;
	void *base;
	mmap_p res;
    SetLastError(0);
	fd=CreateFile(nt_file_name,
    	GENERIC_READ,
        FILE_SHARE_READ,
        NULL,
        OPEN_EXISTING,
        0,
        NULL);
	if(fd==INVALID_HANDLE_VALUE)
		return NULL;
	type=GetFileType(fd);
	size=GetFileSize(fd,NULL);
	md=CreateFileMapping(fd,NULL,PAGE_READONLY,0,size,NULL);
	if(md==INVALID_HANDLE_VALUE)
	{
		CloseHandle(fd);
		return NULL;
	}
	base=MapViewOfFile(md,FILE_MAP_READ,0,0,size);
	if(!base)
	{
		CloseHandle(md);
		CloseHandle(fd);
		return NULL;
	}
    res=(mmap_p)memAlloc(sizeof(mmap_t));
	res->fd=fd;
	res->md=md;
	res->len=size;
	res->base=base;
	return res;
}

void
mmapClose(mmap_t *self)
{
	if(self->md && self->md!=INVALID_HANDLE_VALUE)
	{
		if(self->base)
			UnmapViewOfFile(self->base);
		CloseHandle(self->md);
	}
	if(self->md && self->fd!=INVALID_HANDLE_VALUE)
		CloseHandle(self->fd);
	memFree(self);
}

#define	mmapBase(self)	((self)->base)
#define	mmapSize(self)	((self)->len)

/*	======================================================================
 *	஢ ⥪⮢ 䠩
 */

typedef struct textlines_s
{
	mmap_t		*fm;	/* ⮡ࠦ 䠩    */
	vp_stack_t	rptr;	/* ⥫  砫 ப */
    u_stack_t	lens;	/*  ப   */
}	textlines_t, *textlines_p;

static unsigned
estimate_line_count(unsigned read_in,unsigned total,unsigned read_lines)
{
	if(read_lines==0)
    	return 1000; /* Just guess ... */
	else
    {
    	unsigned line_len = read_in / read_lines;
		return total / line_len;
	}
}

#pragma warning(disable:4100)
static void __stdcall def_progress(int progress,void *param) {}
#pragma warning(default:4100)

/*
 *	textOpen()
 */
textlines_p __declspec(dllexport) __stdcall
textOpen(char *file_name,void (__stdcall *on_progress)(int,void*),void *param)
{
	unsigned p, cp, len, read_lines, total_lines, read_in;
	char *base, *ptr, *end, *start_line;
	textlines_t *self=(textlines_t*)memAlloc(sizeof(textlines_t));
    if(!on_progress)
    	on_progress=def_progress;
    vpsInit(&self->rptr);
    usInit(&self->lens);
    self->fm=mmapOpenRead(file_name);
    if(!self->fm)
    	goto err_cleanup;
	base=(char*)mmapBase(self->fm);
    end=base+mmapSize(self->fm);
    for(p=cp=0,ptr=base;ptr<end;ptr++)
    {
    	while((*ptr==0x0D || *ptr==0x0A) && ptr<end)
        	ptr++;
        start_line=ptr;
    	while(*ptr!=0x0D && *ptr!=0x0A && ptr<end)
        	ptr++;
		len=ptr-start_line;
        if(len)
        {
        	vpsPush(&self->rptr,start_line);
            usPush(&self->lens,len); /* skip EOL */
		}
        read_lines=vpsCount(&self->rptr);
        if(read_lines)
        {
	        read_in=ptr-base;
    	    total_lines=estimate_line_count(read_in,
            	mmapSize(self->fm),read_lines);
	        cp = read_lines * 100 / total_lines;
    	    if(p!=cp)
	        {
    	    	on_progress(cp,param);
        	    p=cp;
			}
		}
    }
    while(cp<99)
    {
    	on_progress(cp,param);
        cp++;
	}
    if(vpsCount(&self->rptr)==0)
    	goto err_cleanup;
	return self;
err_cleanup:;
	if(self)
    {
    	if(self->fm)
        	mmapClose(self->fm);
		vpsClear(&self->rptr);
    	usClear(&self->lens);
	    memFree(self);
	}
    return NULL;
}

/*
 *	textLineCount()
 */
unsigned __declspec(dllexport) __stdcall
textLineCount(textlines_t *self)
{
	return (self) ? vpsCount(&self->rptr) : 0;
}

/*
 *	textLineLen()
 */
unsigned __declspec(dllexport) __stdcall
textLineLen(textlines_t *self,unsigned line)
{
	unsigned count;
	if(!self)
    	return 0;
	count=vpsCount(&self->rptr);
    if(count<=line)
    	return 0;
	return usGet(&self->lens,line);
}

/*
 *	textLine()
 */
unsigned __declspec(dllexport) __stdcall
textLine(textlines_t *self,unsigned line,char *buffer,unsigned buf_len)
{
	unsigned len,count;
	if(!self)
    	return 0;
	count=vpsCount(&self->rptr);
    if(count<=line)
    	return 0;
	len=usGet(&self->lens,line);
	if(len>=buf_len)
    	return 0;
	memCopy(buffer,vpsGet(&self->rptr,line),len);
    buffer[len]=0;
    return len;
}

/*
 *	textClose()
 */
void __declspec(dllexport) __stdcall
textClose(textlines_t *self)
{
	if(self)
    {
    	if(self->fm)
        	mmapClose(self->fm);
		vpsClear(&self->rptr);
    	usClear(&self->lens);
	    memFree(self);
	}
}

/* #define DEBUG */

#ifdef DEBUG

#include <stdio.h>

void __stdcall progress(int count,void *param)
{
	printf("%d %% done ...\n",count);
}

int main()
{
	unsigned i,num_lines,len;
    char *ptr=NULL;
    unsigned size;
	textlines_t *lines=textOpen("db-big.csv",progress);
    if(!lines)
    {
    	printf("Error: rc=%d\n",GetLastError());
        return -1;
	}
    size=4;
    ptr=(char*)malloc(size);
    num_lines=textLineCount(lines);
    for(i=0;i<num_lines;i++)
    {
    	len=textLineLen(lines,i);
        if(!len)
        {
        	printf("can't access line %d\n",i);
            continue;
        }
        printf("line %d has len=%d; ",i,len);
        len+=4;
        if(len>=size)
        {
            size=len;
        	ptr=(char*)realloc(ptr,size);
            if(!ptr)
	        {
    	    	printf("can't realloc(%d)\n",size);
        	    continue;
	        }
		}
        len=textLine(lines,i,ptr,size);
        if(!len)
        {
        	printf("can't access line !\n",i);
            continue;
        }
		fprintf(stdout,"[%s]\n",ptr);
	}
    if(ptr)
    	free(ptr);
	textClose(lines);
    return 0;
}

#endif /* DEBUG */

