/*
**	09.08.1998 - last stable CPP - release.
**	18.07.2000 - rewriting to C.
*/

#include <windows.h>
#include <ddraw.h>

	vboolean	V_GLOBAL	ddrawInit(TODO: see args of vglCreateWindow());
	void		V_GLOBAL	ddrawShutdown(void);
	/* low-level (frame-buffer API) */
	fb_api_p	V_GLOBAL	ddrawGetFBApi(void);
	/* vector API */
	gl_tl_callbacks_p	V_GLOBAL	ddrawGetTlAPI(void);
	/* This one loads D3D and returns 3D - api */
	gl_api_p	V_GLOBAL	ddrawGet ddrawGetDrawApi(void);
	
// =======================================================================
// C2DENGIN.CPP -    'C2DEngine',  -
//    API DirectDraw.
// =======================================================================

typedef	struct	dd_enum_arg_s
{
	DDMODEINFO	*aModes;
	int 		*iNumModes;
}	dd_enum_arg_t, *dd_enum_arg_p;

static HRESULT WINAPI
EnumModesFunc(LPDDSURFACEDESC lpSD,LPVOID lpArg)
{
	dd_enum_arg_p arg=()dd_enum_arg_p)lpArg;
	if(arg->aModes && arg->iNumModes)
	{
		arg->aModes[*arg->iNumModes].cx=lpSD->dwWidth;
		aModes[*arg->iNumModes].cy=lpSD->dwHeight;
		aModes[*arg->iNumModes].bpp=lpSD->ddpfPixelFormat.dwRGBBitCount;
		(*arg->iNumModes)++;
	}
	/*	Break enumeration if aModeInfo full */
	if(*arg->iNumModes >= MAX_SCREEN_MODES) 
		return DDENUMRET_CANCEL;
	else
		return DDENUMRET_OK;
}

void C2DEngine::ResetAll()
{
	LastErrorCode=DDERR_GENERIC;
	lpDDP=NULL;
	lpDDSPrimary=lpDDSBackBuffer=NULL;
	bPrimaryComplex=FALSE;
	iNumModes=0;
	bNLVEnabled=bPageFlip=FALSE;
	memset((LPVOID)OffScreenSurface,0,(MAX_OFFSCREEN_SURFACE+1)*4);
	memset((LPVOID)IsColorKeySet,0,MAX_OFFSCREEN_SURFACE+1);
	memset((LPVOID)AttachedBitmapId,0,(MAX_OFFSCREEN_SURFACE+1)*4);
	memset((LPVOID)OSD,0,(MAX_OFFSCREEN_SURFACE+1)*sizeof(OSD[0]));
}

void C2DEngine::ReleaseAllSurfaces()
{
  if(lpDDP)
  {
    lpDDP->Release();
    Report(" ");
  }
  if(lpDDSPrimary)
  {
    lpDDSPrimary->Release();
    Report("  ");
  }
  if(!bPrimaryComplex)
    if(lpDDSBackBuffer)
    {
      lpDDSBackBuffer->Release();
      Report("  ");
    }
  int i = 0, count = 0;
  while(i<MAX_OFFSCREEN_SURFACE)
  {
    if(OffScreenSurface[i])
    {
      ReleaseOffScreenSurface(i);
      count++;
    }
    i++;
  }
  if(count) Report(" %d  ",count);
  ResetAll();
}

void C2DEngine::RestoreSurfaces()
{
  if(lpDDSPrimary)
  {
    if(lpDDSPrimary->IsLost()==DDERR_SURFACELOST)
    {
      lpDDSPrimary->Restore();
      Report("  ");
    }
    if(!bPrimaryComplex)
    {
      if(lpDDSBackBuffer)
      {
        if(lpDDSBackBuffer->IsLost()==DDERR_SURFACELOST)
        {
          lpDDSBackBuffer->Restore();
          Report("  ");
        }
      }
    }
  }
  int i = 0, count = 0;
  while(i<MAX_OFFSCREEN_SURFACE)
  {
    if(OffScreenSurface[i])
    {
      if(OffScreenSurface[i]->IsLost()==DDERR_SURFACELOST)
      {
        OffScreenSurface[i]->Restore();
        RepaintOffScreenSurface(i);
        count++;
      }
    }
    i++;
  }
  if(count) Report(" %d  ",count);
}

void C2DEngine::Create()
{
  LastErrorCode=DirectDrawCreate(NULL,&lpDD,NULL);
  if(LastErrorCode!=DD_OK)
  {
    Report("     DirectX");
    return;
  }
  ::aModes=this->aModeInfo;
  ::iNumModes=&this->iNumModes;
  LastErrorCode=lpDD->EnumDisplayModes(0,NULL,NULL,EnumModesFunc);
  ::aModes=NULL;
  ::iNumModes=NULL;
  if(LastErrorCode!=DD_OK)
  {
    Report("  ");
    return;
  }
  memset(&HELCaps,0,sizeof(DDCAPS));
  memset(&HALCaps,0,sizeof(DDCAPS));
  HELCaps.dwSize=HALCaps.dwSize=sizeof(DDCAPS);
  LastErrorCode=lpDD->GetCaps(&HALCaps, &HELCaps);
  if(LastErrorCode!=DD_OK)
  {
    Report("    (iDirectDraw)");
    return;
  }
  if(HALCaps.dwCaps2&DDCAPS2_NONLOCALVIDMEM)
  {
    bNLVEnabled=TRUE;
    Report("    AGP");
  }
}

void C2DEngine::Destroy()
{
  ReleaseAllSurfaces();
  if(lpDD)
  {
    lpDD->Release();
    lpDD=NULL;
  }
  lpDDC=NULL;
}

// =======================================================================

C2DEngine::C2DEngine(HWND hWnd)
{
  ResetAll();
  lpDD=NULL;
  lpDDC=NULL;
  this->hWnd=hWnd;
  Create();
  bModeSet=FALSE;
}

C2DEngine::~C2DEngine()
{
  Destroy();
}

void C2DEngine::SetFullScreenMode(int cx, int cy, int bpp, BOOL 
  bForceSystemMemory)
{
  char *szFuncName="C2DEngine::SetFullScreenMode";
  if(LastErrorCode!=DD_OK)
  {
    LastErrorCode=DDERR_GENERIC;
    Report("  %s  ",szFuncName);
    return;
  }
  if(bModeSet)
  {
    LastErrorCode=DDERR_GENERIC;
    Report(" %s     ",szFuncName);
    return;
  }
  bPrimaryComplex=TRUE;
  LastErrorCode=DDERR_GENERIC;
  LastErrorCode=lpDD->SetCooperativeLevel(hWnd,
    DDSCL_EXCLUSIVE|DDSCL_FULLSCREEN);
  if(LastErrorCode!=DD_OK)
  {
    Report("%s:    ",szFuncName);
    return;
  }
  LastErrorCode=lpDD->SetDisplayMode(cx,cy,bpp);
  if(LastErrorCode!=DD_OK)
  {
    Report("%s:  %d X %d X %d bpp .",szFuncName,cx,cy,bpp);
    return;
  }
  DDSURFACEDESC sd;
  memset(&sd,0,sizeof(sd));
  sd.dwSize=sizeof(sd);
  sd.dwFlags=DDSD_CAPS|DDSD_BACKBUFFERCOUNT;
  sd.ddsCaps.dwCaps=DDSCAPS_PRIMARYSURFACE|DDSCAPS_FLIP
    |DDSCAPS_COMPLEX|DDSCAPS_VIDEOMEMORY;
  if(HALCaps.dwCaps&DDCAPS_3D) sd.ddsCaps.dwCaps|=DDSCAPS_3DDEVICE;
  sd.dwBackBufferCount=2;
  if(bForceSystemMemory) goto TrySystemMemory;
  LastErrorCode=lpDD->CreateSurface(&sd,&lpDDSPrimary,NULL);
  if(LastErrorCode!=DD_OK)
  {
    sd.dwBackBufferCount=1;
    LastErrorCode=lpDD->CreateSurface(&sd,&lpDDSPrimary,NULL);
    if(LastErrorCode!=DD_OK)
    {
TrySystemMemory:    
      sd.ddsCaps.dwCaps&=~(DWORD)DDSCAPS_VIDEOMEMORY;
      LastErrorCode=lpDD->CreateSurface(&sd,&lpDDSPrimary,NULL);
      if(LastErrorCode!=DD_OK)
      {
        Report("   ");
        lpDDSPrimary=NULL;
        return;
      }
    }
  }
  DDSCAPS sc;
  memset(&sc,0,sizeof(DDSCAPS));
  sc.dwCaps=DDSCAPS_BACKBUFFER;
  LastErrorCode=lpDDSPrimary->GetAttachedSurface(&sc,&lpDDSBackBuffer);
  if(LastErrorCode!=DD_OK)
  {
    Report("   ");
    LastErrorCode=DDERR_UNSUPPORTED;
    lpDDSPrimary->Release();
    lpDDSPrimary=NULL;
    return;
  }
  bModeSet=TRUE;
  DWORD ts=timeGetTime();
  SetFlipMode(TRUE);
  // ,     :)
  for(;;)
  {
    ClearBackBuffer(0);
    lpDD->WaitForVerticalBlank(DDWAITVB_BLOCKBEGIN,NULL);
    Flip();
    if((ts+100)<timeGetTime()) break;
  }
  return;
}

int C2DEngine::CreateOffScreenSurface(int width,int height)
{
  int i=0, iSurface;
  while(OffScreenSurface[i]) i++;
  if(i==MAX_OFFSCREEN_SURFACE)
  {
    Report("   ");
    return -1;
  }
  iSurface=i;
  IDirectDrawSurface *lpDDS;
  DDSURFACEDESC sd;
  memset(&sd,0,sizeof(sd));
  sd.dwSize=sizeof(sd);
  sd.dwWidth=width;
  sd.dwHeight=height;
  sd.dwFlags=DDSD_WIDTH|DDSD_HEIGHT|DDSD_CAPS;
  sd.ddsCaps.dwCaps=DDSCAPS_OFFSCREENPLAIN|DDSCAPS_VIDEOMEMORY|
    DDSCAPS_LOCALVIDMEM;
  LastErrorCode=lpDD->CreateSurface(&sd,&lpDDS,NULL);
  if(LastErrorCode!=DD_OK)
  {
    if(bNLVEnabled)
    {
      sd.ddsCaps.dwCaps=DDSCAPS_OFFSCREENPLAIN|DDSCAPS_VIDEOMEMORY|
        DDSCAPS_NONLOCALVIDMEM;
      LastErrorCode=lpDD->CreateSurface(&sd,&lpDDS,NULL);
      if(LastErrorCode==DD_OK) goto FixUp;
    }
    sd.ddsCaps.dwCaps=DDSCAPS_OFFSCREENPLAIN|DDSCAPS_SYSTEMMEMORY;
    LastErrorCode=lpDD->CreateSurface(&sd,&lpDDS,NULL);
    if(LastErrorCode!=DD_OK)
    {
      Report("   ");
      return -1;
    }
  }
FixUp:
  OffScreenSurface[iSurface]=lpDDS;
  OSD[iSurface].Width=width;
  OSD[iSurface].Height=height;
  OSD[iSurface].Caps=sd.ddsCaps.dwCaps;
  return iSurface;
}

void C2DEngine::ReleaseOffScreenSurface(int iSurfNum)
{
  if(iSurfNum>=MAX_OFFSCREEN_SURFACE)
  {
    LastErrorCode=DDERR_GENERIC;
    return;
  }
  OffScreenSurface[iSurfNum]->Release();
  OffScreenSurface[iSurfNum]=NULL;
  AttachedBitmapId[iSurfNum]=NULL;
  memset(&OSD[iSurfNum],0,sizeof(OSD[0]));
  LastErrorCode=DD_OK;
}

void C2DEngine::SetPalette(PALETTEENTRY *PalEntries)
{
  if(lpDDP) lpDDP->Release();
  LastErrorCode=lpDD->CreatePalette(DDPCAPS_8BIT,PalEntries,&lpDDP,NULL);
  if(LastErrorCode!=DD_OK)
  {
    Report("  ");
    lpDDP=NULL;
    return;
  }
  if(lpDDSPrimary)
  {
    LastErrorCode=lpDDSPrimary->SetPalette(lpDDP);
    if(LastErrorCode==DDERR_SURFACELOST)
    {
      RestoreSurfaces();
      LastErrorCode=lpDDSPrimary->SetPalette(lpDDP);
    }
    if(LastErrorCode!=DD_OK)
    {
      Report("  ");
      lpDDP->Release();
      lpDDP=NULL;
    }
  }
}

void C2DEngine::SetDIBPalette(char *lpszId)
{
  CDib dib;
  dib.Load(lpszId);
  if((dib.LastError())||(dib.GetDibNumColors()!=256)) return;
  SetPalette(dib.GetPaletteEntries());
}

HDC C2DEngine::GetPrimaryDC()
{
  HDC dc;
  if(lpDDSPrimary)
  {
    TryToGetDC:
      LastErrorCode=lpDDSPrimary->GetDC(&dc);
      switch(LastErrorCode)
      {
        case DDERR_SURFACELOST:
          RestoreSurfaces();
        case DDERR_WASSTILLDRAWING:
          goto TryToGetDC;
        case DD_OK:
          break;
        default:
          dc=NULL;
          break;
      }
  } else dc=NULL;
  return dc;
}

HDC C2DEngine::GetBackBufferDC()
{
  HDC dc;
  if(lpDDSBackBuffer)
  {
    TryToGetDC:
      LastErrorCode=lpDDSBackBuffer->GetDC(&dc);
      switch(LastErrorCode)
      {
        case DDERR_SURFACELOST:
          RestoreSurfaces();
        case DDERR_WASSTILLDRAWING:
          goto TryToGetDC;
        case DD_OK:
          break;
        default:
          dc=NULL;
          break;
      }
  } else dc=NULL;
  return dc;
}

HDC C2DEngine::GetOffScreenDC(int iSurfNum)
{
  HDC dc;
  if(iSurfNum>=MAX_OFFSCREEN_SURFACE)
  {
    LastErrorCode=DDERR_GENERIC;
    return NULL;
  }
  IDirectDrawSurface *lpOSS=OffScreenSurface[iSurfNum];
  if(lpOSS)
  {
    TryToGetDC:
      LastErrorCode=lpOSS->GetDC(&dc);
      switch(LastErrorCode)
      {
        case DDERR_SURFACELOST:
          RestoreSurfaces();
        case DDERR_WASSTILLDRAWING:
          goto TryToGetDC;
        case DD_OK:
          break;
        default:
          dc=NULL;
          break;
      }
  } else dc=NULL;
  return dc;
}

void C2DEngine::ReleasePrimaryDC(HDC dc)
{
  if(lpDDSPrimary)
  {
    TryToReleaseDC:
      LastErrorCode=lpDDSPrimary->ReleaseDC(dc);
      switch(LastErrorCode)
      {
        case DDERR_SURFACELOST:
          RestoreSurfaces();
          goto TryToReleaseDC;
        default:
          break;
      }
  }
  return;
}

void C2DEngine::ReleaseBackBufferDC(HDC dc)
{
  if(lpDDSBackBuffer)
  {
    TryToReleaseDC:
      LastErrorCode=lpDDSBackBuffer->ReleaseDC(dc);
      switch(LastErrorCode)
      {
        case DDERR_SURFACELOST:
          RestoreSurfaces();
          goto TryToReleaseDC;
        default:
          break;
      }
  }
  return;
}

void C2DEngine::ReleaseOffScreenDC(int iSurfNum, HDC dc)
{
  if(iSurfNum>=MAX_OFFSCREEN_SURFACE)
  {
    LastErrorCode=DDERR_GENERIC;
    return;
  }
  IDirectDrawSurface *lpOSS=OffScreenSurface[iSurfNum];
  if(lpOSS)
  {
    TryToReleaseDC:
      LastErrorCode=lpOSS->ReleaseDC(dc);
      switch(LastErrorCode)
      {
        case DDERR_SURFACELOST:
          RestoreSurfaces();
          goto TryToReleaseDC;
        default:
          break;
      }
  }
  return;
}

void C2DEngine::ClearPrimarySurface(DWORD dwColor)
{
  if(lpDDSPrimary)
  {
    DDBLTFX ddbltfx;
    ddbltfx.dwSize = sizeof(ddbltfx);
    ddbltfx.dwFillColor = dwColor;
    TryToClear:
      LastErrorCode=lpDDSPrimary->Blt(NULL,NULL,NULL,
        DDBLT_COLORFILL|DDBLT_WAIT,&ddbltfx);
      switch(LastErrorCode)
      {
        case DDERR_SURFACELOST:
          RestoreSurfaces();
        case DDERR_WASSTILLDRAWING:
          goto TryToClear;
        default:
          break;
      }
  }
}

void C2DEngine::ClearBackBuffer(DWORD dwColor)
{
  if(lpDDSBackBuffer)
  {
    DDBLTFX ddbltfx;
    ddbltfx.dwSize = sizeof(ddbltfx);
    ddbltfx.dwFillColor = dwColor;
    TryToClear:
      LastErrorCode=lpDDSBackBuffer->Blt(NULL,NULL,NULL,
        DDBLT_COLORFILL|DDBLT_WAIT,&ddbltfx);
      switch(LastErrorCode)
      {
        case DDERR_SURFACELOST:
          RestoreSurfaces();
        case DDERR_WASSTILLDRAWING:
          goto TryToClear;
        default:
          break;
      }
  }
}

void C2DEngine::ClearSurface(int iSurfNum, DWORD dwColor)
{
  if(iSurfNum>=MAX_OFFSCREEN_SURFACE)
  {
    LastErrorCode=DDERR_GENERIC;
    return;
  }
  IDirectDrawSurface *lpOSS=OffScreenSurface[iSurfNum];
  if(lpOSS)
  {
    DDBLTFX ddbltfx;
    ddbltfx.dwSize = sizeof(ddbltfx);
    ddbltfx.dwFillColor = dwColor;
    TryToClear:
      LastErrorCode=lpOSS->Blt(NULL,NULL,NULL,
        DDBLT_COLORFILL|DDBLT_WAIT,&ddbltfx);
      switch(LastErrorCode)
      {
        case DDERR_SURFACELOST:
          RestoreSurfaces();
        case DDERR_WASSTILLDRAWING:
          goto TryToClear;
        default:
          break;
      }
  }
}

void C2DEngine::SetColorKey(int iSurfNum, int lk, int hk)
{
  if(iSurfNum>=MAX_OFFSCREEN_SURFACE)
  {
    LastErrorCode=DDERR_GENERIC;
    return;
  }
  IDirectDrawSurface *lpOSS=OffScreenSurface[iSurfNum];
  if(lpOSS)
  {
    DDCOLORKEY kk;
    kk.dwColorSpaceLowValue=lk;
    kk.dwColorSpaceHighValue=hk;
    TryToSetColorKey:
      LastErrorCode=lpOSS->SetColorKey(DDCKEY_SRCBLT,&kk);
      switch(LastErrorCode)
      {
        case DDERR_SURFACELOST:
          RestoreSurfaces();
        case DDERR_WASSTILLDRAWING:
          goto TryToSetColorKey;
        default:
          break;
      }
  }
  if(LastErrorCode==DD_OK) IsColorKeySet[iSurfNum]=0xFF;
}

void C2DEngine::Blit(IDirectDrawSurface *lpDDSDest,RECT *lprcDest,
  IDirectDrawSurface *lpDDSSrc, RECT *lprcSrc)
{
  if(!lpDDSDest||!lpDDSSrc)
  {
    LastErrorCode=DDERR_GENERIC;
    return;
  }
  TryToBlit:
    LastErrorCode=lpDDSDest->Blt(lprcDest,lpDDSSrc,lprcSrc,DDBLT_WAIT,NULL);
    switch(LastErrorCode)
    {
      case DDERR_SURFACELOST:
        RestoreSurfaces();
      case DDERR_WASSTILLDRAWING:
        goto TryToBlit;
      default:
        break;
    }
}

void C2DEngine::Blit(RECT *lprcDest,int iDDSSrc, RECT *lprcSrc)
{
  if((!lpDDSBackBuffer)||(iDDSSrc>=MAX_OFFSCREEN_SURFACE)||
     (OffScreenSurface[iDDSSrc]==NULL))
  {
    LastErrorCode=DDERR_GENERIC;
    return;
  }
  DWORD dwFlags = (IsColorKeySet[iDDSSrc]) ?
    DDBLT_WAIT|DDBLT_KEYSRC : DDBLT_WAIT;
  TryToBlit:
    LastErrorCode=lpDDSBackBuffer->Blt(lprcDest,OffScreenSurface[iDDSSrc],
      lprcSrc,dwFlags,NULL);
    switch(LastErrorCode)
    {
      case DDERR_SURFACELOST:
        RestoreSurfaces();
      case DDERR_WASSTILLDRAWING:
        goto TryToBlit;
      default:
        break;
    }
}

void C2DEngine::BlitBitmap(int iDestSurf, RECT *lprcDest,
  RECT *lprcSrc, void *lpBits, BITMAPINFO *lpBitsInfo, UINT uUsage,
  DWORD dwRop)
{
  HDC dc=GetOffScreenDC(iDestSurf);
  if(LastErrorCode!=DD_OK) return;
  if(StretchDIBits(dc,lprcDest->left, lprcDest->top,
    lprcDest->right-lprcDest->left, lprcDest->bottom-lprcDest->top,
    lprcSrc->left, lprcSrc->top,
    lprcSrc->right-lprcSrc->left, lprcSrc->bottom-lprcSrc->top,
    lpBits,lpBitsInfo,uUsage, dwRop)==GDI_ERROR)
    LastErrorCode=DDERR_GENERIC;
  else
    LastErrorCode=DD_OK;
  ReleaseOffScreenDC(iDestSurf,dc);
}

void C2DEngine::Flip()
{
  if(bPrimaryComplex && bPageFlip)
  {
    if(lpDDSPrimary)
    {
      LastErrorCode=lpDDSPrimary->Flip(NULL,DDFLIP_WAIT);
      if(LastErrorCode==DDERR_SURFACELOST)
      {
        RestoreSurfaces();
        LastErrorCode=lpDDSPrimary->Flip(NULL,DDFLIP_WAIT);
      }
    }
  }
  else
  {
    if(lpDDSPrimary&&lpDDSBackBuffer)
      Blit(lpDDSPrimary,NULL,lpDDSBackBuffer,NULL);
  }
}

void C2DEngine::SetFlipMode(BOOL bPageFlip)
{
  this->bPageFlip=bPageFlip;
}

void C2DEngine::RepaintOffScreenSurface(int iSurfNum)
{
  RECT dest, src;
  char *dibid=AttachedBitmapId[iSurfNum];
  if(dibid)
  {
    CDib dib;
    dib.Load(dibid);
    if(dib.LastError()) return;
    dest.left=dest.top=src.left=src.top=0;
    dest.right=src.right=dib.GetDibWidth();
    dest.bottom=src.bottom=dib.GetDibHeight();
    BlitBitmap(iSurfNum,&dest,&src,dib.GetDIBits(),dib.GetDibBMI(),
      DIB_RGB_COLORS,SRCCOPY);
  }
}

int C2DEngine::AttachBitmap(char *lpszId)
{
  RECT dest, src;
  CDib dib;
  dib.Load(lpszId);
  if(dib.LastError()) return -1;
  int ioss=CreateOffScreenSurface(dib.GetDibWidth(),dib.GetDibHeight());
  if(LastErrorCode!=DD_OK) return -1;
  dest.left=dest.top=src.left=src.top=0;
  dest.right=src.right=dib.GetDibWidth();
  dest.bottom=src.bottom=dib.GetDibHeight();
  BlitBitmap(ioss,&dest,&src,dib.GetDIBits(),dib.GetDibBMI(),
    DIB_RGB_COLORS,SRCCOPY);
  AttachedBitmapId[ioss]=lpszId;
  return ioss;
}

BOOL C2DEngine::IsValidSurface(int iSurfNum)
{
  return ((iSurfNum<0)||(iSurfNum>=MAX_OFFSCREEN_SURFACE)) ? FALSE : TRUE;
}

void C2DEngine::EnableNLV(BOOL bEnable)
{
  bNLVEnabled=bEnable && (HALCaps.dwCaps2&DDCAPS2_NONLOCALVIDMEM);
}

BOOL C2DEngine::IsNLVEnabled(void)
{
  return bNLVEnabled;
}

BOOL C2DEngine::IsNLVAvailable(void)
{
  return HALCaps.dwCaps2&DDCAPS2_NONLOCALVIDMEM;
}

DWORD C2DEngine::GetAvailableMem(DWORD dwSurfaceCaps)
{
  LPDIRECTDRAW2 lpDD2;
  DDSCAPS       ddsCaps;
  DWORD         dwTotal;
  DWORD         dwFree;
  if(!lpDD)
  {
    LastErrorCode=DDERR_GENERIC;
    return 0;
  }
  LastErrorCode=lpDD->QueryInterface(IID_IDirectDraw2,(void**)&lpDD2);
  if(LastErrorCode!=DD_OK) return 0;
  memset(&ddsCaps,0,sizeof(DDSCAPS));
  ddsCaps.dwCaps=dwSurfaceCaps;
  LastErrorCode=lpDD2->GetAvailableVidMem(&ddsCaps,&dwTotal,&dwFree);
  lpDD2->Release();
  if(LastErrorCode!=DD_OK) return 0;
  return dwFree;
}

DWORD C2DEngine::GetAvailableLocalVidMem(void)
{
  return GetAvailableMem(DDSCAPS_VIDEOMEMORY|DDSCAPS_LOCALVIDMEM);
}

DWORD C2DEngine::GetAvailableNonlocalVidMem(void)
{
  return GetAvailableMem(DDSCAPS_VIDEOMEMORY|DDSCAPS_NONLOCALVIDMEM);
}

void C2DEngine::GetOSD(int iSurfNum,DWORD *lpdwWidth,DWORD *lpdwHeight,
  DWORD *lpdwCaps)
{
  if((iSurfNum>=MAX_OFFSCREEN_SURFACE)||(!OffScreenSurface[iSurfNum]))
  {
    LastErrorCode=DDERR_GENERIC;
    return;
  }
  *lpdwWidth=OSD[iSurfNum].Width;
  *lpdwHeight=OSD[iSurfNum].Height;
  *lpdwCaps=OSD[iSurfNum].Caps;
}
