#include "../../include/v_lib.hpp"
#include "../../devel/include/v_show.hpp"
#pragma hdrstop
#include <stdio.h>

vec_p vec3Refine(vec3_t v)
{
  for(int i=0;i<3;i++) if(IsZero(v[i])) v[i]=0;
  return v;
}

void main()
{
  vec3_t dst,dir,src,origin,delta;
  vec3Set(dir,1,2,3);
  vec3Set(origin,3,2,4);
  vec3Copy(src,origin);
  vec_t rad=M_PI/1.23465;
  int i,loops=1000000;
  timeStart();
  printf("Rotating vector around arbitrary axis %d times...\n",loops);
  for(i=0;i<loops;i+=2)
  {
    vec3RotateAroundQ(dst,dir,src,rad);
    vec3RotateAroundQ(src,dir,dst,rad);
  }
  timeStop();
  printf("Quake: %d loops,%g seconds, res:\n",loops,(double)timeMilliseconds()/1000);
  showvec3(src);
  printf("Delta - abs = %g\n",v_abs(vec3Abs(src)-vec3Abs(origin)));
  vec3Copy(src,origin);
  timeStart();
  for(i=0;i<loops;i+=2)
  {
    vec3RotateAround(dst,dir,src,rad);
    vec3RotateAround(src,dir,dst,rad);
  }
  timeStop();
  printf("Mesa: %d loops,%g seconds, res:\n",loops,(double)timeMilliseconds()/1000);
  showvec3(src);
  printf("Delta - abs = %g\n",v_abs(vec3Abs(src)-vec3Abs(origin)));
}

