#define	SGI_GL_H
#include <GL/osmesa.h>
#include <v_lib.h>

void
DrawScene()
{
	glClearColor(0,.25,.25,.5);
	glClear(GL_COLOR_BUFFER_BIT);
	glViewport(0,0,256,256);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glOrtho(-1,1,-1,1,-1,1);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	glColor4f(1,1,0,.4);
	glRectf(-.9,-.9,0,0);
	glColor4f(0,1,1,.4);
	glRectf(0,0,.5,.5);
}

void
SaveScene(int width,int height,void *buffer)
{
#if 0
	int len;
	void *row;
	u32_t *ptr1,*ptr2;
	row=(void*)memAlloc(4*width);
	/* Mirror image vertically */
	len=width<<2;
	ptr1=(u32_t*)buffer;
	ptr2=ptr1+len*(height-1);
	while(ptr1<ptr2)
	{
		memCopy(row,ptr1,len);
		memCopy(ptr1,ptr2,len);
		memCopy(ptr2,row,len);
		ptr1+=width;
		ptr2-=width;
	}
#endif
	bmpSave("out.bmp",width,height,buffer);
	// memFree(row);
}

int
main()
{
	OSMesaContext ctx;
	void *buffer;
	ctx=OSMesaCreateContext(OSMESA_RGBA,NULL);
	if(!ctx)
	{
		perror("OSMesaCreateContext()");
		return -1;
	}
	buffer=(void*)malloc(256*256*4);
	if(!OSMesaMakeCurrent(ctx,buffer,GL_UNSIGNED_BYTE,256,256))
	{
		perror("OSMesaMakeCurrent()");
		free(buffer);
		OSMesaDestroyContext(ctx);
		return -1;
	}
	DrawScene();
	SaveScene(256,256,buffer);
	free(buffer);
	OSMesaDestroyContext(ctx);
	return 0;
}
