

// todo - add field: struct ring_buffer_t *next;

typedef struct ring_buffer_p
{
	u8_t	*buffer;
	int		len, cursor;
}	ring_buffer_t, *ring_buffer_t;

	rbfInit(ring_buffer_t *buf,void *data,u32_t len);
	/* 'pos' CAN be greater than data len in buffer */
	rbfSeek(ring_buffer_t *buf,int offset);
	rbfAdvance(ring_buffer_t *buf,int delta);
	rbfGet(ring_buffer_t *buf,void *dest,u32_t dest_len);
	
rbfInit(ring_buffer_t *buf,void *data,u32_t len)
{
	buf->buffer=(u8_t*)data;
	buf->len=(int)len;
	buf->cursor=0;
}

rbfSeek(ring_buffer_t *buf,int offset);
{
	buf->cursor = offset % buf->len;
}

rbfAdvance(ring_buffer_t *buf,int delta)
{
	buf->cursor = (buf->cursor + delta) % buf->len;
}

rgGet(ring_buffer_t *buf,void *dest,u32_t dest_len)
{
	int startlen; /* length of start block */
	int fullblocks; /* number of full blocks */
	int remainder; /* lenght of end block */
	u8_t *ptr;
	int i;
	startlen=buf->len-buf->cursor;
	if(startlen<=dest_len)
	{
		...
		return;
	}
	remainder=dest_len-start_len;
	fullblocks=remainder / buf->len;
	remainder-=fullblocks * buf->len;
	ptr=(u8_t*)dest;
	memCopy(dest,buf->buffer + buf->cursor,startlen);
	ptr+=startlen;
	for(i=0;i<fullblocks;i++,ptr+=buf->len)
		memCopy(ptr,buf->buffer,buf->len);
	memCopy(ptr,buf->buffer,remainder);
	buf->cursor=remainder;
}
