/* its fully operable, but textures must be duplicated in new context ! */

vboolean	V_GLOBAL
vglDrawToBitmap(char *file_name,u32_t width,u32_t height,
	u32_t mmWidth,u32_t mmHeight,
	void (V_CALL *DrawProc)(void *param),void *param)
{
	glw_t cur,ctx;
	void *pixels;
	char ext[_MAX_EXT];
	GLfloat projection_matrix[16];
	GLfloat modelview_matrix[16];
	u32_t rw, rh;
	vboolean res;
	if(!file_name || !file_name[0] || !width || !height || !DrawProc)
	{
#ifdef	CHECKED_BUILD
		conlPrintf(LOG_ERROR,"vglDrawToBitmap(%s,%u,%u,%u,%u,%X,%X): "
			"incorrect parameter(s).\n",
			dbs(file_name),width,height,mmWidth,mmHeight,DrawProc,param);
#endif	/* CHECKED_BUILD */
		return false;
	}
	cur=vglGetCurrentWindow();
	if(!cur)
	{
#ifdef	CHECKED_BUILD
		conlPrintf(LOG_ERROR,"vglDrawToBitmap(%s,%u,%u,%u,%u,%X,%X): "
			"current context is NULL.\n",
			dbs(file_name),width,height,mmWidth,mmHeight,DrawProc,param);
#endif	/* CHECKED_BUILD */
		return false;
	}
	glGetFloatv(GL_MODELVIEW_MATRIX,modelview_matrix);
	glGetFloatv(GL_PROJECTION_MATRIX,projection_matrix);
	ctx=vglCreateOffscreenWindow(width,height);
	if(!ctx)
	{
#ifdef	CHECKED_BUILD
		conlPrintf(LOG_ERROR,"vglDrawToBitmap(%s,%u,%u,%u,%u,%X,%X): "
			"vglCreateOffscreenWindow(%u,%u) failed.\n",
			dbs(file_name),width,height,mmWidth,mmHeight,DrawProc,param,
			width,height);
#endif	/* CHECKED_BUILD */
		if(vglGetCurrentWindow() != cur)
			vglMakeCurrent(cur);
		return false;
	}
	glMatrixMode(GL_PROJECTION);
	glLoadMatrixf(projection_matrix);
	glMatrixMode(GL_MODELVIEW);
	glLoadMatrixf(modelview_matrix);
	DrawProc(param);
	pixels=vglReadPixels(&rw,&rh);
	if(!pixels)
	{
#ifdef	CHECKED_BUILD
		conlPrintf(LOG_WARNING,"vglDrawToBitmap(%s,%u,%u,%u,%u,%X,%X): "
			"vglReadPixels() failed.\n",
			dbs(file_name),width,height,mmWidth,mmHeight,DrawProc,param);
#endif	/* CHECKED_BUILD */
		vglDestroyWindow(ctx);
		if(vglGetCurrentWindow() != cur)
			vglMakeCurrent(cur);
		return false;
	}
#ifdef	CHECKED_BUILD
	if(rw!=width || rh!=height)
	{
		conlPrintf(LOG_WARNING,"vglDrawToBitmap(%s,%u,%u,%u,%u,%X,%X): "
			"vglReadPixels() returned wrong dimensions (%u by %u).\n",
			dbs(file_name),width,height,mmWidth,mmHeight,DrawProc,param,
			rw,rh);
	}
#endif	/* CHECKED_BUILD */
	/* determine file format */
	if(!strcasecmp(file_name,"//./clipboard"))
		res=bmpSaveEx(file_name,rw,rh,pixels,mmWidth,mmHeight);
	else
	{
		fsSplitPath(file_name,NULL,NULL,NULL,ext);
		if(!strcasecmp(ext,"bmp"))
			res=bmpSaveEx(file_name,rw,rh,pixels,mmWidth,mmHeight);
		else if(!strcasecmp(ext,"tga"))
		{
#ifdef	CHECKED_BUILD
			if(mmWidth || mmHeight)
				conlPrintf(LOG_WARNING,
					"vglDrawToBitmap(%s,%u,%u,%u,%u,%X,%X): "
					"Targa format specified, ignoring image size "
					"%u by %u millimeters.\n",
					dbs(file_name),width,height,mmWidth,mmHeight,
					DrawProc,param,mmWidth,mmHeight);
#endif	/* CHECKED_BUILD */
			res=tgaSave(file_name,rw,rh,pixels);
		}
		else
		{
#ifdef	CHECKED_BUILD
			conlPrintf(LOG_ERROR,"vglDrawToBitmap(%s,%u,%u,%u,%u,%X,%X): "
				"unknown file format '%s'.\n",
				dbs(file_name),width,height,mmWidth,mmHeight,DrawProc,
				param,ext);
#endif	/* CHECKED_BUILD */
			res=false;
		}
	}
	return res;
}

