#define CHECKED_BUILD
#define	BUILD_DLL
#define MULTITHREADED

/*
 *	This code is DEBUGGED and partially moved to v_gl.c
 */
 
#include <stdio.h>
#include <v_lib.h>
#include "../../win_vga/win_vga.h"
#include "../../../source/v_mt.h"
#include "../../../source/win32/os.h"

keycode_t	V_LOCAL
keycodeWin32Code(u32_t wp,u32_t lp)
{
	keycode_t key=0;
	unsigned char scan=(unsigned char)((lp>>16) & 0xFF);
	unsigned char ext=(unsigned char)((lp & (1<<24)) != 0);
	
	switch(wp)
	{
		case VK_ESCAPE:	key=key_escape; break;
		case '1':		key=key_1; break;
		case '2':		key=key_2; break;
		case '3':		key=key_3; break;
		case '4':		key=key_4; break;
		case '5':		key=key_5; break;
		case '6':		key=key_6; break;
		case '7':		key=key_7; break;
		case '8':		key=key_8; break;
		case '9':		key=key_9; break;
		case '0':		key=key_0; break;
		case 189:		key=key_minus; break;
		case 187:		key=key_equal; break;
		case VK_BACK:	key=key_backspace; break;
		case VK_TAB:	key=key_tab; break;
		case 'Q':		key=key_Q; break;
		case 'W':		key=key_W; break;
		case 'E':		key=key_E; break;
		case 'R':		key=key_R; break;
		case 'T':		key=key_T; break;
		case 'Y':		key=key_Y; break;
		case 'U':		key=key_U; break;
		case 'I':		key=key_I; break;
		case 'O':		key=key_O; break;
		case 'P':		key=key_P; break;
		case 219:		key=key_left_bracket; break;
		case 221:		key=key_right_bracket; break;
		case VK_RETURN:	key=ext ? key_gray_enter : key_enter; break;
		case 17:		key=
			ext ? key_right_control : key_left_control; break;
		case 18:		key=ext ? key_right_alt : key_left_alt; break;
		case 'A':		key=key_A; break;
		case 'S':		key=key_S; break;
		case 'D':		key=key_D; break;
		case 'F':		key=key_F; break;
		case 'G':		key=key_G; break;
		case 'H':		key=key_H; break;
		case 'J':		key=key_J; break;
		case 'K':		key=key_K; break;
		case 'L':		key=key_L; break;
		case 186:		key=key_colon; break;
		case 222:		key=key_apostrophe; break;
		case 192:		key=key_back_quote; break;
		case 16:		key=
			(scan==42) ? key_left_shift : key_right_shift; break;
		case 220:		key=key_back_slash; break;
        case 'Z':		key=key_Z; break;
		case 'X':		key=key_X; break;
		case 'C':		key=key_C; break;
		case 'V':		key=key_V; break;
		case 'B':		key=key_B; break;
		case 'N':		key=key_N; break;
		case 'M':		key=key_M; break;
		case 188:		key=key_comma; break;
		case 190:		key=key_dot; break;
		case 191:		key=key_slash; break;
		case VK_F1:		key=key_f1; break;
		case VK_F2:		key=key_f2; break;
		case VK_F3:		key=key_f3; break;
		case VK_F4:		key=key_f4; break;
		case VK_F5:		key=key_f5; break;
		case VK_F6:		key=key_f6; break;
		case VK_F7:		key=key_f7; break;
		case VK_F8:		key=key_f8; break;
		case VK_F9:		key=key_f9; break;
		case VK_F10:	key=key_f10; break;
		case VK_F11:	key=key_f11; break;
		case VK_F12:	key=key_f12; break;
		case VK_NUMLOCK:	key=key_numlock; break;
		case VK_SCROLL:	key=key_scrolllock; break;
		case 32:		key=key_space; break;
		case 20:		key=key_capslock; break;
		case 91:		key=key_left_win; break;
		case 92:		key=key_right_win; break;
		case 93:		key=key_context; break;
		case 111:		key=key_gray_slash; break;
		case 106:		key=key_gray_asterisk; break;
		case 109:		key=key_gray_minus; break;
		case 107:		key=key_gray_plus; break;
		case 12:		key=key_numpad_5; break;
		default:
			switch(scan)
			{
				case 71:	key=(ext) ? key_home : key_numpad_7; break;
				case 72:	key=(ext) ? key_up : key_numpad_8; break;
				case 73:	key=(ext) ? key_pageup : key_numpad_9; break;
				case 75:	key=(ext) ? key_left : key_numpad_4; break;
				case 77:	key=(ext) ? key_right : key_numpad_6; break;
				case 79:	key=(ext) ? key_end : key_numpad_1; break;
				case 80:	key=(ext) ? key_down : key_numpad_2; break;
				case 81:	key=(ext) ? key_pagedown : key_numpad_3; break;
				case 82:	key=(ext) ? key_insert : key_numpad_0; break;
				case 83:	key=(ext) ? key_delete : key_numpad_dot; break;
				case 69:	key=key_pause; break;
				case 55:	key=key_printscreen; break;
				default:	key=0; break;
			}
		break;
	}
	return key;
}

vboolean V_LOCAL
wm_process_message(ipc_handle_t dst,MSG *src,thread_data_t *td)
{
	input_event_t event;
	i32_t first_code, second_code;
	switch(src->message)
	{
		case WM_KEYDOWN:
		case WM_SYSKEYDOWN:
#ifndef		ENABLE_AUTOREPEAT
			if(src->lParam & 0x40000000)
				return true;
#endif		/* ENABLE_AUTOREPEAT */
			event=ev_key_down;
			first_code=keycodeWin32Code(src->wParam,src->lParam);
			switch(first_code)
			{
				case key_left_shift:
				case key_right_shift:
					td->lower_case=false;
					break;
				case key_capslock:
					td->caps_lock=!td->caps_lock;
					break;
				case key_numlock:
					td->num_lock=!td->num_lock;
					break;
			}
			second_code=keycodeGetChar(first_code,
				td->caps_lock ? !td->lower_case : td->lower_case,NULL);
			break;
		case WM_KEYUP:
		case WM_SYSKEYUP:
			event=ev_key_up;
			first_code=keycodeWin32Code(src->wParam,src->lParam);
			switch(first_code)
			{
				case key_left_shift:
				case key_right_shift:
					td->lower_case=true;
					break;
			}
			second_code=0;
			break;
		case WM_MOUSEMOVE:
			event=ev_mouse_move;
			first_code=LOWORD(src->lParam);
			second_code=HIWORD(src->lParam);
			if(first_code & 0x8000)
				first_code|=0xFFFF0000;
			if(second_code & 0x8000)
				second_code|=0xFFFF0000;
			break;
		case WM_LBUTTONDOWN:
			event=ev_key_down;
			first_code=key_left_mouse;
			second_code=0;
			break;
		case WM_MBUTTONDOWN:
			event=ev_key_down;
			first_code=key_middle_mouse;
			second_code=0;
			break;
		case WM_RBUTTONDOWN:
			event=ev_key_down;
			first_code=key_right_mouse;
			second_code=0;
			break;
		case WM_LBUTTONUP:
			event=ev_key_up;
			first_code=key_left_mouse;
			second_code=0;
			break;
		case WM_MBUTTONUP:
			event=ev_key_up;
			first_code=key_middle_mouse;
			second_code=0;
			break;
		case WM_RBUTTONUP:
			event=ev_key_up;
			first_code=key_right_mouse;
			second_code=0;
			break;
		default:
			return false;
	}
	inPostEvent(dst,event,first_code,second_code);
	return true;
}

V_LOCAL	DWORD	CALLBACK
wm_input_thread_entry(LPVOID param)
{
	MSG msg;
	ipc_handle_t srv;
	char *srv_name;
	thread_data_t *td;
	logStartConsoleLog();
	logUpperLevel(LOG_TRACE);
	srv_name=param ? (char*)param : "WindowedInput";
	srv=ipcServerEndpoint(srv_name);
	if(!srv)
	{
#ifdef	CHECKED_BUILD
		conlPrintf(LOG_ERROR,
			"wm_input_thread(): server '%s' already started.\n",srv_name);
#endif	/* CHECKED_BUILD */
		logStopConsoleLog();
		ExitThread(0);
	}
	td=GetThreadData();
	td->num_lock=true;
	td->caps_lock=false;
	td->lower_case=true;
	while(GetMessage(&msg,NULL,0,0))
		wm_process_message(srv,&msg,td);
	/*
	if(wm_process_message(srv,&msg))
		return 0;
	else
		return DefWindowProc()...
	*/
	ipcClose(srv);
	logStopConsoleLog();
	ExitThread(1);
	return 0;
}

DWORD	wm_input_thread_id;
HANDLE	wm_input_thread;

vboolean V_GLOBAL
inwStartServer(void)
{
	if(wm_input_thread)
		return false;
	wm_input_thread=CreateThread(NULL,0,wm_input_thread_entry,
		NULL,0,&wm_input_thread_id);
	if(!wm_input_thread || 
		WaitForSingleObject(wm_input_thread,100)!=WAIT_TIMEOUT)
	{
		wm_input_thread=NULL;
		return false;
	}
	return true;
}

void	V_GLOBAL
inwStopServer(void)
{
	if(!wm_input_thread)
		return;
	PostThreadMessage(wm_input_thread_id,WM_QUIT,0,0);
	WaitForSingleObject(wm_input_thread,INFINITE);
	wm_input_thread=NULL;
}

/* DEBUG */

void d(input_record_t *ev)
{
	switch(ev->event)
	{
		case ev_key_down:
			if(ev->second_code)
				printf("Key DOWN: '%s', char '%c'\n",
					keycodeGetName(ev->first_code),
					ev->second_code);
			else
				printf("Key DOWN: '%s'\n",keycodeGetName(ev->first_code));
			break;
		case ev_key_up:
			printf("Key UP:   '%s'\n",keycodeGetName(ev->first_code));
			break;
		case ev_mouse_move:
			printf("mouse_move(%d,%d)\n",ev->first_code,ev->second_code);
			break;
	}
}

extern DWORD parent_thread_id;

int main()
{
	ipc_handle_t cl;
	input_record_t in;

	ipcInit();
	inwStartServer();
	
	graphInitWinDIB(320,200);
	cl=ipcClientEndpoint("WindowedInput");
	if(!cl)
		return -1;

	/* HACK */
	parent_thread_id=wm_input_thread_id;
	
	do
	{
		inGetEvent(cl,&in,true);
		d(&in);
	}	while(in.first_code!=key_escape);

	graphShutdownWinDIB();
	
	ipcClose(cl);
	
	inwStopServer();
	
	ipcShutdown();
	return 0;
}
