/*<html><body bgcolor=#B4C4B0><font color=#000000><strong><pre>*/
#ifndef V_REF2D_H
#define V_REF2D_H
/*		<font color=#FFFFFF>
        rendering_context_t::caps, graph_settings_t::caps
</font>*/
#define CTX_PALETTED                (1<<0)
#define CTX_COLORRGB                (1<<1)
#define CTX_3D                      (1<<2)
#define CTX_HELPER                  (1<<3)
#define CTX_ACCELERATED             (1<<4)
#define CTX_FULLSCREEN              (1<<5)
#define CTX_ENHFONTS                (1<<6)
/*<font color=#FFFFFF>
        graph_settings_t
</font>*/
typedef struct  graph_settings_s
{
  int   sizex,sizey,bpp;
  u32_t  caps;
} graph_settings_t;
/*<font color=#FFFFFF>
        font effects
</font>*/
#define EF_BOLD               ((u32_t)(1<<0))
#define EF_ITALIC             ((u32_t)(1<<1))
#define EF_UNDERLINE          ((u32_t)(1<<2))
#define EF_STRIKEOUT          ((u32_t)(1<<3))
/*<font color=#FFFFFF>
        Helper API: OS-specific (not implemented for now)
</font>*/
typedef struct refhlpapi_s
{
  vboolean  (V_CALL *iskeydown)(int code);
  void      (V_CALL *getmousexy)(int *x,int *y);
  void      (V_CALL *setmousexy)(int x,int y);
  void      (V_CALL *showmouse)(vboolean show);
} refhlpapi_t, *refhlpapi_p;
/*<font color=#FFFFFF>
        2D rendering API
</font>*/
typedef struct ref2dapi_s
{
  void      (V_CALL *clearviewport)(void_p gc);
  void      (V_CALL *moveto)(void_p gc,int x,int y);
  void      (V_CALL *lineto)(void_p gc,int x,int y);
  void      (V_CALL *line)(void_p gc,int x1,int y1,int x2,int y2);
  void      (V_CALL *rectangle)(void_p gc,int x1,int y1,int x2,int y2);
  void      (V_CALL *bar)(void_p gc,int x1,int y1,int x2,int y2);
  void      (V_CALL *circle)(void_p gc,int x,int y,int radius);
  void      (V_CALL *ellipse)(void_p gc,int x1,int y1,int x2,int y2);
  void      (V_CALL *triangle)(void_p gc,int x1,int y1,int x2,int y2,int x3,int y3);
  /*        Note: font width may be zero */
  void      (V_CALL *usefont)(void_p gc,int sizex,int sizey,
                                 vec_t direction,u32_t effects,char *name);
  void      (V_CALL *getextent)(void_p gc,char *str,int *sx,int *sy);
  void      (V_CALL *outtext)(void_p gc,char *str);
  void      (V_CALL *outtextxy)(void_p gc,int x,int y,char *str);
  void      (V_CALL *setcolor)(void_p gc,int r,int g,int b);
  void      (V_CALL *setbkcolor)(void_p gc,int r,int g,int b);
  void      (V_CALL *settextcolor)(void_p gc,int r,int g,int b);
  vboolean  (V_CALL *loadpalette)(void_p gc,char *unix_resname);
  void      (V_CALL *setindex)(void_p gc,int index);
  void      (V_CALL *setbkindex)(void_p gc,int index);
  void      (V_CALL *settextindex)(void_p gc,int index);
} ref2dapi_t, *ref2dapi_p;
/*<font color=#FFFFFF>
        3D api  - stub for now
</font>*/
typedef struct ref3dapi_s
{
  void      (V_CALL *_r3d_begin_2d)(void_p gc);
  void      (V_CALL *_r3d_end_2d)(void_p gc);
  void      (V_CALL *stub)(void_p gc);
} ref3dapi_t, *ref3dapi_p;
/*<font color=#FFFFFF>
        rendering_context_t
</font>*/
typedef struct  rendering_context_s
{
  /*        Platform - independent data =============================== */
  int               sizex;            /* size in device units (pixels)  */
  int               sizey;
  int               bpp;              /* bit depth                      */
  u32_t              caps;
  /*        Event handlers (client side) ============================== */
  notifyevent_t     on_idle;
  notifyevent_t     on_activate;
  notifyevent_t     on_deactivate;
  notifyevent_t     on_destroy;
  keyevent_t        on_keydown;
  keyevent_t        on_keyup;
  mouseevent_t      on_mousedown;
  mouseevent_t      on_mouseup;
  mouseevent_t      on_mousemove;
  sysevent_t        sysevent;                     /* platform-dependent */
  /*        Pointers to rendering functions =========================== */
  ref2dapi_t        r2d;
  ref3dapi_t        r3d;
  refhlpapi_t       rhlp;
  /*        Platform - specific data ================================== */
  void              *ctx_data;                    /* platform-dependent */
} rendering_context_t, *gc_t;
/*<h4><font face="Arial" color=#FFFFFF>
        Function's prototypes.
</h4></font>*/
#ifdef __cplusplus
extern "C" {
#endif

/*          =================================         *\
 *                       *
\*          =================================         */
  gc_t      V_GLOBAL graphCreateContext(graph_settings_t *start);
  void      V_GLOBAL graphDeleteContext(gc_t context);
  void      V_GLOBAL graphMakeCurrent(gc_t context);
  gc_t      V_GLOBAL graphGetCurrentContext(void);
  void      V_GLOBAL graphFlush(gc_t c);
  void      V_GLOBAL graphSetHandler(gc_t c,event_type_t evtype,void *handler);
  void      V_GLOBAL graphResetHandler(gc_t c,event_type_t evtype);
/*          =================================         *\
 *           .                        *
\*          =================================         */
/*          =================================         *\
 *  false    , *
 *    .  *
 * .                                     *
\*          =================================         */
  vboolean  V_GLOBAL graphProcessSysMessages(void);
/*          =================================         *\
 *    .              *
\*          =================================         */
  int       V_GLOBAL graphSysMessageloop(void);
/*          =================================         *\
 *                                  *
\*          =================================         */
  int       V_GLOBAL getmaxx();
  int       V_GLOBAL getmaxy();
  u32_t      V_GLOBAL getcaps();
/*                  */
  void      V_GLOBAL clearviewport(void);
  void      V_GLOBAL moveto(int x,int y);
  void      V_GLOBAL lineto(int x,int y);
  void      V_GLOBAL line(int x1,int y1,int x2,int y2);
  void      V_GLOBAL rectangle(int x1,int y1,int x2,int y2);
  void      V_GLOBAL bar(int x1,int y1,int x2,int y2);
  void      V_GLOBAL circle(int x,int y,int radius);
  void      V_GLOBAL ellipse(int x1,int y1,int x2,int y2);
  void      V_GLOBAL triangle(int x1,int y1,int x2,int y2,int x3,int y3);
  void      V_GLOBAL usefont(int sizex,int sizey,vec_t direction,
                            u32_t effects,char *name);
  void      V_GLOBAL getextent(char *str,int *sx,int *sy);
  void      V_GLOBAL outtext(char *str);
  void      V_GLOBAL outtextxy(int x,int y,char *str);
  void      V_GLOBAL setcolor(int r,int g,int b);
  void      V_GLOBAL setbkcolor(int r,int g,int b);
  void      V_GLOBAL settextcolor(int r,int g,int b);
  vboolean  V_GLOBAL loadpalette(char *unix_resname);
  void      V_GLOBAL setindex(int index);
  void      V_GLOBAL setbkindex(int index);
  void      V_GLOBAL settextindex(int index);
/*          TODO: implement and connect 3D api */
#ifdef __cplusplus
}
#endif

#endif
/*</font></pre></html>*/
