/*<html><body bgcolor=#B4C4B0><font color=#000000><strong><pre>*/
#ifndef   V_PARSE_H
#define   V_PARSE_H

typedef	void	*parser_t;

#ifdef  __cplusplus
extern  "C" {
#endif	/* __cplusplus */
	/* Returns malloc()'ed block, buffer NOT copied into block */
    parser_t	V_GLOBAL	tokStart(char *buffer,char *delim);
	/* Returns malloc()'ed block, with entire file copied into it */
    parser_t	V_GLOBAL	tokStartFile(char *filename,char *delim);
	/* Resets position to start, optionally (if 'new_buffer' != NULL) 
	 * sets new source for parsing. */
    void		V_GLOBAL	tokRestart(parser_t tok,char *new_buffer);
	/* Saving/restoring parser position */
    vboolean	V_GLOBAL	tokPush(parser_t tok);
    vboolean	V_GLOBAL	tokPop(parser_t tok);
    void		V_GLOBAL	tokDelim(parser_t tok,char *delim);
	/*	Returns either string inside 'buffer' (if created  with
	 *	tokStart()), or string inside 'tok' (if created  with
	 *	tokStartFile()).
	 */
    char_p		V_GLOBAL	tokNext(parser_t tok);
	/*
	 *	Same as tokNext(), whitespace threats as normal chars.
	 */
    char_p		V_GLOBAL	tokStrict(parser_t tok);
    /*	Returns next string (i.e. sequence ended with EOL);
	 *	EOL itself NOT stored in result.
	 */
	char_p		V_GLOBAL	tokString(parser_t tok);
    /*
	 *	Returns last result of tok[Next | Strict | String].
	 *	NOTE. Can be called ONLY AFTER AT LEAST ONE call of
	 *	mentioned above procs; otherwise result is unpredictable.
	 */
	char_p		V_GLOBAL	tokLast(parser_t tok);
	/*	Releases all memory */
	void		V_GLOBAL	tokFree(parser_t tok);
#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* V_PARSE_H */
/*</pre></strong></body></html>*/
/*EOF*/
