/*<html><body bgcolor=#B4C4B0><font color=#000000><strong><pre>*/
#ifndef	V_WAVLIB_H
#define V_WAVLIB_H

typedef	void					*wave_handle_t;

#ifdef	__cplusplus
extern "C" {
#endif	/* __cplusplus */
	/*	Input functions. ============================================== */
	/*	Opens WAV file for input. Returns wave handle of NULL on error. */
	wave_handle_t	V_GLOBAL	wavOpenRead(char *name);
	/*	Reads next data block from file. Returns number of read BYTES. */
	u32_t			V_GLOBAL	wavRead(wave_handle_t handle,void *dest,u32_t len);
	/*	Closes wave file, previously opened for input or output. */
	vboolean		V_GLOBAL	wavClose(wave_handle_t handle);
	/*	Output functions. ============================================= */
	/*	Starts writing of wav file. Returned handle must be later 
	 *	passed to wavClose(). */
	wave_handle_t	V_GLOBAL	wavOpenWrite(char *name,
		u32_t num_channels,u32_t sampling_frequency,u32_t bits_per_sample);
	/*	Writes 'len' bytes to wave file, returns number of wrote bytes */
	u32_t			V_GLOBAL	wavWrite(wave_handle_t handle,void *src,u32_t len);
	/*	Input function for small files. ================================ */
	/*	Loads entire file, stores pointer to data in resuls->wave_data.
	 *	Returns pointer to single memAlloc()'ed block (containing both
	 *	format struct and wave data), so result must be later memFree()'d.
	 */
	wave_handle_t	V_GLOBAL	wavLoad(char *name);
	/*	Helper functions. ============================================= */
	u32_t			V_GLOBAL	wavNumChannels(wave_handle_t handle);
	u32_t			V_GLOBAL	wavSamplingFrequency(wave_handle_t handle);
	u32_t			V_GLOBAL	wavBitsPerSample(wave_handle_t handle);
	u32_t			V_GLOBAL	wavNumSamples(wave_handle_t handle);
	/*	!!! Only for handles returned by wavLoad(). */
	void_p			V_GLOBAL	wavData(wave_handle_t handle);
#ifdef	__cplusplus
}
#endif	/* __cplusplus */

#endif	/* V_WAVLIB_H */
/*</pre></body></html>*/
/*EOF*/
