#include <v_lib.h>

char	*str="Hello";

void V_CALL
second_thread(void *arg)
{
	u32_t count;
	char buf[128];
	rwl_fifo_t accum=(rwl_fifo_t)arg;
	conPuts("THREAD2: Started.\n");
	memZero(buf,sizeof(buf));
	conPrintf("THREAD2: %d bytes in accum, waiting for input ...\n",
		rwlCount(accum));
	for(;;)
	{
		count=rwlPopBuffer(accum,buf,strlen(str)+1);
		if(count)
			break;
		/* conPrintf("rwlPopBuffer(): no data ...\n"); */
		schedYield();
		/* timeDelay(500); */
	}
	conPrintf("Received %d bytes: '%s'\n",count,buf);
	threadExit(0);
}

int main()
{
	rwl_fifo_t accum;
	thread_t recv_thread;
	logStartConsoleLog();
	logUpperLevel(LOG_TRACE);
	accum=rwlCreate();
	/*
	rwlBlockMode(accum,false); : will reaturn 'Hel' after 1 second.
	*/
	conPuts("Spawning second thread ...\n");
	recv_thread=threadCreate(second_thread,accum);
	timeDelay(1000);
	rwlPushBuffer(accum,str,3);
	timeDelay(1000);
	rwlPushBuffer(accum,str,5);
	threadJoin(recv_thread,NULL);
	rwlDestroy(accum);
	return 0;
}
