#include <v_lib.h>

ntree_p	store_int(int n,ntree_t *parent)
{
	return treeStore(&n,sizeof(int),parent);
}

void	traverse_r(ntree_t *node)
{
	u32_t ind,count;
	ntree_p *ch;
	if(!node)
		return;
	printf("Node data: %d\n",*((int*)node->data));
	ch=(ntree_p*)vpsGetStorage(&node->children);
	count=vpsCount(&node->children);
	for(ind=0;ind<count;ind++)
		traverse_r(ch[ind]);
}

#define	N_WAYS		3

int main()
{
	ntree_t *node,*children[N_WAYS];
	int i,j;
	logStartConsoleLog();
	logUpperLevel(LOG_TRACE);
	/* Root node */
	node=store_int(0,NULL);
	/* Level 1 */
	for(i=0;i<N_WAYS;i++)
		children[i]=store_int(i+1,node);
	/* Level 2 */
	for(j=0;j<3;j++)
	{
		node=children[j];
		for(i=0;i<N_WAYS;i++)
			store_int(i+1 + 10*(j+1),node);
	}
	/* Traverse */
	node=treeRootNode(node);
	traverse_r(node);
	/* Delete tree */
	treeDeleteAllNodes(node,NULL);
	return 0;
}
