/*
 * A demonstration of using the VGL functions.
 */
#include "../../include/v_lib.h"

GLfloat a = 0, b = 0;

static void rect(void)
{
	glBegin(GL_QUADS);
		glColor4f(1,1,0,.5f);
		glVertex2f(-1,-1);
		glColor4f(0,1,1,.5f);
		glVertex2f(-1,1);
		glColor4f(1,0,1,.5f);
		glVertex2f(1,1);
		glColor4f(1,1,1,.5f);
		glVertex2f(1,-1);
	glEnd();
}
		
static void redraw()
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	glScalef(.5f,.5f,.5f);
	glRotatef(a,1,0,0);
	glRotatef(b,0,1,0);
	rect();
	vglSwapBuffers();
	a+=1;
	b+=.2f;
}

/*
static void resize( unsigned int width, unsigned int height )
{
   printf("Resize event\n");
   glViewport( 0, 0, width, height );
   glMatrixMode( GL_PROJECTION );
   glLoadIdentity();
   glOrtho( -1.0, 1.0, -1.0, 1.0, -1.0, 1.0 );
}
*/

static void event_loop()
{
	int done=0;
	input_record_t event;
	while(!done)
	{
		if(!vglPending())
		{
			 redraw();
			timeDelay(30);
			continue;
		}
		vglNextEvent(&event);
		switch(event.event)
		{
			case ev_key_down:
				printf("KeyPress: %s (%u:'%c')\n",
					keycodeGetName(event.first_code),
					event.first_code,
					event.second_code);
				if(event.first_code==key_f10)
					done=1;
				break;
			case ev_key_up:
				printf("KeyRelease: %s\n",
					keycodeGetName(event.first_code));
				break;
			case ev_mouse_move:
				printf("Mouse moved: (%u,%u)\n",
					event.first_code,
					event.second_code);
				break;
		}
	}
}

int main( int argc, char *argv[] )
{
	glw_t win;
	logStartConsoleLog();
	logUpperLevel(LOG_TRACE);
	// win = vglCreateWindow("OpenGL test",10,10,256,256);
	win = vglCreateFullscreenWindow("OpenGL test",0,0,0,0);
	if(!win)
		return -1;
	glShadeModel(GL_SMOOTH);
	glClearColor(0,0,0,1);
	glClear(GL_COLOR_BUFFER_BIT);
	vglSwapBuffers();
	event_loop();
	vglDestroyWindow(win);
	return 0;
}
