self=gcc.mak
a=a
o=o
ar=ar rc
mv=mv
rm=rm -f
target=libv
rootdir=..
lang=c
libdir=$(rootdir)/arch/unix
cc=nice -10 gcc
cflags=-c -Wall -pedantic -D__UNIX__ $(cdebug) -idirafter $(rootdir)/include
cdebug=-ggdb
#	=======================================================================
all:
	make -f $(self) lib
	make -f $(self) install
#	make -f $(self) clean
#	=======================================================================
objfiles=v_fifo.$(o) v_fs.$(o) v_log.$(o) v_math.$(o) v_matrix.$(o) \
	v_objlib.$(o) v_parse.$(o) v_pgrid.$(o) v_pprof.$(o) v_plane.$(o) \
	v_space.$(o) v_stack.$(o) v_str.$(o) v_vector.$(o) v_image.$(o) \
	v_time.$(o) v_camctl.$(o) v_tlist.$(o) v_mt.$(o) v_gpsp.$(o) \
	v_sched.$(o) v_kcode.$(o) v_glx.$(o) v_tree.$(o) v_wavlib.$(o) \
	v_comm.$(o) \
	v_reg.$(o) v_wavin.$(o) fbase.$(o) fsbase.$(o) fstree.$(o) iobase.$(o) \
    mbase.$(o) fspakfs.$(o) fslist.$(o) vfsutil.$(o) vfsmap.$(o)
#	=======================================================================
libdjpegdir=../support/jpeglib6b
jdobjfiles=jdapimin.$(o) jdapistd.$(o) jdtrans.$(o) jdatasrc.$(o) \
	jdmaster.$(o) jdinput.$(o) jdmarker.$(o) jdhuff.$(o) jdphuff.$(o) \
	jdmainct.$(o) jdcoefct.$(o) jdpostct.$(o) jddctmgr.$(o) jidctfst.$(o) \
	jidctflt.$(o) jidctint.$(o) jidctred.$(o) jdsample.$(o) jdcolor.$(o) \
	jquant1.$(o) jquant2.$(o) jdmerge.$(o) jcomapi.$(o) jutils.$(o) \
	jerror.$(o) jmemmgr.$(o) jmemnobs.$(o)
$(jdobjfiles):
	make -C $(libdjpegdir)
	$(mv) $(libdjpegdir)/*.$(o) ./
#	=======================================================================
srcfiles=$(objfiles:.$(o)=.$(lang))
lib:$(target).a
$(target).a:$(objfiles) $(jdobjfiles)
	$(ar) $(target).a $(objfiles) $(jdobjfiles)
v_mt.$(o):v_mt.$(lang)
	$(cc) $(cflags) v_mt.$(lang)
v_time.$(o):v_time.$(lang)
	$(cc) $(cflags) v_time.$(lang)
v_input.$(o):v_input.$(lang)
	$(cc) $(cflags) v_input.$(lang)
v_wmf.$(o):v_wmf.$(lang)
	$(cc) $(cflags) v_wmf.$(lang)
v_glx.$(o):unix/v_glx.$(lang)
	$(cc) $(cflags) unix/v_glx.$(lang)
iobase.$(o):vfs/iobase.$(lang)
	$(cc) $(cflags) vfs/iobase.$(lang)
fsbase.$(o):vfs/fsbase.$(lang)
	$(cc) $(cflags) vfs/fsbase.$(lang)
fstree.$(o):vfs/fstree.$(lang)
	$(cc) $(cflags) vfs/fstree.$(lang)
mbase.$(o):vfs/mbase.$(lang)
	$(cc) $(cflags) vfs/mbase.$(lang)
fbase.$(o):vfs/fbase.$(lang)
	$(cc) $(cflags) vfs/fbase.$(lang)
vfsutil.$(o):vfs/vfsutil.$(lang)
	$(cc) $(cflags) vfs/vfsutil.$(lang)
vfsmap.$(o):vfs/vfsmap.$(lang)
	$(cc) $(cflags) vfs/vfsmap.$(lang)
fspakfs.$(o):vfs/drivers/fspakfs.$(lang)
	$(cc) $(cflags) vfs/drivers/fspakfs.$(lang)
fslist.$(o):vfs/drivers/fslist.$(lang)
	$(cc) $(cflags) vfs/drivers/fslist.$(lang)
.$(lang).$(o):
	$(cc) $(cflags) $(ansi) $*.$(lang)
install:
	$(rm) $(libdir)/$(target).$(a)
	$(mv) $(target).a $(libdir)/$(target).$(a)
clean:
	$(rm) $(objfiles)
	$(rm) $(jdobjfiles)
