/*<html><body bgcolor=#000080><font color=#C0C0B0><strong><pre>*/
#include	<v_lib.h>
#include	<../source/v_mt.h>
#include	<../source/vfs/iobase.h>
#include	<../source/vfs/fsbase.h>
#include	<../source/vfs/fbase.h>
#include	<../source/vfs/vfsutil.h>

#ifndef		RIGHT_SLASHED

void	V_CALL
uvfsReplaceExt(char *dst,char *name,char *ext)
{
	char fname[_MAX_PATH];
	vfsSplitName(name,fname,NULL);
    vfsMakePath(dst,NULL,fname,ext);
}

void	V_CALL
nvfsReplaceExt(char *dst,char *name,char *ext)
{
	char uname[_MAX_PATH];
    vfsNative2Unix(uname,name);
	uvfsReplaceExt(dst,uname,ext);
    if(name)
	    vfsUnix2Native(name,uname);
}

void	V_CALL
nvfsSplitPath(char *src,char *dir,char *name,char *ext)
{
	char uname[_MAX_PATH];
    vfsNative2Unix(uname,src);
	vfsSplitPath(uname,dir,name,ext);
    /* convert parts back to DOS style */
    if(dir)
    {
        vfsUnix2Native(uname,dir);
        strCopy(dir,uname,_MAX_DIR);
	}
    if(name)
    {
        vfsUnix2Native(uname,name);
        strCopy(name,uname,_MAX_FNAME);
    }
    if(ext)
    {
        vfsUnix2Native(uname,ext);
        strCopy(ext,uname,_MAX_EXT);
	}
}

void	V_CALL
nvfsMakePath(char *dest_path,char *dir,char *name,char *ext)
{
	char uname[_MAX_PATH];
    char ud[_MAX_DIR], un[_MAX_FNAME], ue[_MAX_EXT];
    /* convert parts back to UNIX style */
    if(dir)
    {
        vfsNative2Unix(ud,dir);
        dir=ud;
	}
    if(name)
    {
        vfsNative2Unix(un,name);
        name=un;
    }
    if(ext)
    {
        vfsNative2Unix(ue,ext);
        ext=ue;
	}
	vfsMakePath(uname,dir,name,ext);
    vfsUnix2Native(dest_path,uname);
}

file_t	V_CALL
ufileOpenRead(char *name)
{
	file_t ret;
	ret=lfsCreateFile(name,filemode_read);
	if(ret)
		return ret;
	return vfsCreateFile(name);
}

file_t	V_CALL
nfileOpenRead(char *name)
{
	char uname[_MAX_PATH];
    vfsNative2Unix(uname,name);
    return ufileOpenRead(uname);
}

file_t	V_CALL
ufileOpenWrite(char *name)
{
	return lfsCreateFile(name,filemode_write);
}

file_t	V_CALL
nfileOpenWrite(char *name)
{
	char uname[_MAX_PATH];
    vfsNative2Unix(uname,name);
	return lfsCreateFile(uname,filemode_write);
}

file_t	V_CALL
ufileOpenAppend(char *name)
{
	return lfsCreateFile(name,filemode_append);
}

file_t	V_CALL
nfileOpenAppend(char *name)
{
	char uname[_MAX_PATH];
    vfsNative2Unix(uname,name);
	return lfsCreateFile(uname,filemode_append);
}

/* Declares in v_mt.c */
extern file_apis_t	*unix_apis_ptr;
extern file_apis_t	*native_apis_ptr;

vboolean	V_GLOBAL
fsAreApisUnix(void)
{
	if(GetThreadData()->file_apis==unix_apis_ptr)
    	return true;
	else
    	return false;
}

void		V_GLOBAL
fsSetApisUnix(void)
{
	GetThreadData()->file_apis=unix_apis_ptr;
}

void		V_GLOBAL
fsSetApisNative(void)
{
	GetThreadData()->file_apis=native_apis_ptr;
}

vboolean	V_GLOBAL
fsNative2Unix(char *unix_name,char *dos_name)
{
	return vfsNative2Unix(unix_name,dos_name);
}

vboolean	V_GLOBAL
fsUnix2Native(char *dos_name,char *unix_name)
{
	return vfsUnix2Native(dos_name,unix_name);
}

void	V_GLOBAL
fsEnumFiles(void (V_CALL *dir_callback)(char *full_unix_style_dir_name),
	void (V_CALL *file_callback)(char *full_unix_style_file_name),
	vboolean recursive)
{
	GetThreadData()->file_apis->fsEnumFiles(dir_callback,
    	file_callback,recursive);
}

void	V_GLOBAL
fsSplitPath(char *src,char *dir,char *name,char *ext)
{
	GetThreadData()->file_apis->fsSplitPath(src,dir,name,ext);
}

void	V_GLOBAL
fsMakePath(char *dest_path,char *dir,char *name,char *ext)
{
	GetThreadData()->file_apis->fsMakePath(dest_path,
    	dir,name,ext);
}

void	V_GLOBAL
fsReplaceExt(char *dst,char *name,char *ext)
{
	GetThreadData()->file_apis->fsReplaceExt(dst,name,ext);
}

file_t	V_GLOBAL
fileOpenRead(char *name)
{
	return GetThreadData()->file_apis->fileOpenRead(name);
}

file_t	V_GLOBAL
fileOpenWrite(char *name)
{
	return GetThreadData()->file_apis->fileOpenWrite(name);
}

file_t	V_GLOBAL
fileOpenAppend(char *name)
{
	return GetThreadData()->file_apis->fileOpenAppend(name);
}

#else	/* RIGHT_SLASHED */

void	V_GLOBAL
fsEnumFiles(void (V_CALL *dir_callback)(char *full_unix_style_dir_name),
	void (V_CALL *file_callback)(char *full_unix_style_file_name),
	vboolean recursive)
{
	lfsEnumFiles(dir_callback,file_callback,recursive);
}

void	V_GLOBAL
fsSplitPath(char *src,char *dir,char *name,char *ext)
{
	vfsSplitPath(src,dir,name,ext);
}

void	V_GLOBAL
fsMakePath(char *dest_path,char *dir,char *name,char *ext)
{
	vfsMakePath(dest_path,dir,name,ext);
}

void	V_GLOBAL
fsReplaceExt(char *dst,char *name,char *ext)
{
	char fname[_MAX_PATH];
	vfsSplitName(name,fname,NULL);
    vfsMakePath(dst,NULL,fname,ext);
}

file_t	V_GLOBAL
fileOpenRead(char *name)
{
	file_t ret;
	ret=lfsCreateFile(name,filemode_read);
	if(ret)
		return ret;
	return vfsCreateFile(name);
}

file_t	V_GLOBAL
fileOpenWrite(char *name)
{
	return lfsCreateFile(name,filemode_write);
}

file_t	V_GLOBAL
fileOpenAppend(char *name)
{
	return lfsCreateFile(name,filemode_append);
}

#endif	/* RIGHT_SLASHED */

void	V_GLOBAL
fsInit(void)
{
	vfsInit();
}

void	V_GLOBAL
fsShutdown()
{
	vfsShutdown();
}

vboolean	V_GLOBAL
fileEof(file_t file)
{
	return fileTell(file)==fileSize(file);
}

char_t	V_GLOBAL
fileGetc(file_t file)
{
	char_t val;
	fileRead(file,&val,1);
	return val;
}

vboolean V_GLOBAL
filePutc(file_t file,int c)
{
	return fileWrite(file,&c,1) ? true : false;
}

vboolean V_GLOBAL
filePuts(file_t file,char *str)
{
	int len, wrlen;
	if(!str)
	{
#ifdef	CHECKED_BUILD
		conlPuts(LOG_ERROR,"filePuts(NULL): invalid parameter.\n");
#endif	/* CHECKED_BUILD */
		return false;
	}
	len=strlen(str);
	wrlen=fileWrite(file,str,len) + (int)filePutc(file,0x0A);
	return ((len+1)==wrlen) ? true : false;
}

/*
 *	TODO: rewrite to use pctl_map_ispace.
 */
int		V_GLOBAL
fileGets(file_t file,char *buf,int n)
{
	char c;
	char *next;
	if(!buf || !n)
	{
#ifdef	CHECKED_BUILD
		conlPrintf(LOG_ERROR,
			"fileGets(%X,%X,%d): invalid parameter(s).\n",file,buf,n);
#endif	/* CHECKED_BUILD */
		return 0;
	}
	for(;;)
	{
		c=(char)fileGetc(file);
		if(c!=0x0d && c!=0x0a)
			break;
		else
			/* reached EOF while inside a whitespace */
			if(fileEof(file))
				return 0;
	}
	/* 'c' can be last char in file; we copy it anyway */
	for(next=buf;(next-buf)<n-1;)
	{
		*next=c;
		next++;
		c=(char)fileGetc(file);
		if(c==0x0d || c==0x0a || fileEof(file))
			break;
	}
	*next=0;
	return next-buf;
}

/*
 *	filePrintf
 */
vboolean	V_GLOBAL_VA
filePrintf(file_t file,const char *fmt,...)
{
	va_list marker;
	char *ptr;
	char fmt_buffer[MAX_FORMAT_BUFFER];
	u32_t len, wrlen;
	if(!fmt)
	{
#ifdef	CHECKED_BUILD
		conlPuts(LOG_ERROR,"filePrintf(NULL): invalid 'fmt'.\n");
#endif	/* CHECKED_BUILD */
		return false;
	}
	ptr=fmt_buffer;
	va_start(marker,fmt);
	len=vsprintf(ptr,fmt,marker);
	va_end(marker);
    if(len>=MAX_FORMAT_BUFFER)
    {
#ifdef	CHECKED_BUILD
		conlPuts(LOG_ERROR,
        	"filePrintf(): too many args; heap destoyed.\n");
#endif	/* CHECKED_BUILD */
		return false;
    }
	wrlen=fileWrite(file,ptr,len);
	return (len==wrlen) ? true : false;
}

/*
 *	Returns word stored in file in little-endian order.
 */
u16_t	V_GLOBAL
fileGetLittleShort(file_t file)
{
#ifndef	BIG_ENDIAN
	u16_t w;
	fileRead(file,&w,2);
	return w;
#else	/* BIG_ENDIAN */
	u32_t b1, b2;
	b1 = fileGetc(file); /* get low byte */
	b2 = fileGetc(file); /* get hi byte */
	return (u16_t)(((b2<<8) & 0xFF00) | (b1 & 0xFF));
#endif	/* BIG_ENDIAN */
}

/*
 *	Stores word in file in little-endian order.
 */
void	V_GLOBAL
filePutLittleShort(file_t file,u16_t w)
{
#ifndef	BIG_ENDIAN
	fileWrite(file,&w,2);
#else	/* BIG_ENDIAN */
	filePutc(file,(u8_t)(w & 0xFF)); /* put low byte */
	filePutc(file,(u8_t)((w >> 8) & 0xFF)); /* put hi byte */
#endif	/* BIG_ENDIAN */
}

/*
 *	Returns double word stored in file in little-endian order.
 */
u32_t	V_GLOBAL
fileGetLittleLong(file_t file)
{
#ifndef	BIG_ENDIAN
	u32_t dw;
	fileRead(file,&dw,4);
	return dw;
#else	/* BIG_ENDIAN */
	u32_t b1, b2, b3, b4;
	b1 = (u32_t)fileGetc(file);
	b2 = (u32_t)fileGetc(file);
	b3 = (u32_t)fileGetc(file);
	b4 = (u32_t)fileGetc(file);
	return (u32_t)(((b4<<24) & 0xFF000000) | ((b3<<16) & 0xFF0000) | 
		((b2<<8) & 0xFF00) | (b1 & 0xFF));
#endif	/* BIG_ENDIAN */
}

/*
 *	Stores dword in little-endian order.
 */
void	V_GLOBAL
filePutLittleLong(file_t file,u32_t dw)
{
#ifndef	BIG_ENDIAN
	fileWrite(file,&dw,4);
#else	/* BIG_ENDIAN */
	filePutc(file,(u8_t)(dw & 0xFF));
	filePutc(file,(u8_t)((dw & 0xFF00) >> 8));
	filePutc(file,(u8_t)((dw & 0xFF0000) >> 16));
	filePutc(file,(u8_t)((dw & 0xFF000000) >> 24));
#endif	/* BIG_ENDIAN */
}

/*</pre></strong></body></html>*/
/*EOF*/
