/*<html><body bgcolor=#000080><font color=#C0C0B0><strong><pre>*/
#include	<v_lib.h>
#include	<../source/v_mt.h>

/*
 *	Returns name associated with given keyboard code.
 */
char_p	V_GLOBAL
keycodeGetName(keycode_t code)
{
	switch(code)
	{
		case key_escape:	return "Escape";
		case key_1:			return "1";
		case key_2:			return "2";
		case key_3:			return "3";
		case key_4:			return "4";
		case key_5:			return "5";
		case key_6:			return "6";
		case key_7:			return "7";
		case key_8:			return "8";
		case key_9:			return "9";
		case key_0:			return "0";
		case key_minus:		return "Minus";
		case key_equal:		return "Plus";
		case key_backspace:	return "Backspace";
		case key_tab:		return "Tab";
		case key_Q:			return "Q";
		case key_W:			return "W";
		case key_E:			return "E";
		case key_R:			return "R";
		case key_T:			return "T";
		case key_Y:			return "Y";
		case key_U:			return "U";
		case key_I:			return "I";
		case key_O:			return "O";
		case key_P:			return "P";
		case key_left_bracket:	return "Left bracket";
		case key_right_bracket:	return "Right bracket";
		case key_enter:		return "Enter";
		case key_left_control:	return "Left control";
		case key_A:			return "A";
		case key_S:			return "S";
		case key_D:			return "D";
		case key_F:			return "F";
		case key_G:			return "G";
		case key_H:			return "H";
		case key_J:			return "J";
		case key_K:			return "K";
		case key_L:			return "L";
		case key_colon:		return "Colon";
		case key_apostrophe:	return "Apostrophe";
		case key_back_quote:	return "Back quote";
		case key_left_shift:	return "Left shift";
		case key_back_slash:	return "Backslash";
		case key_Z:			return "Z";
		case key_X:			return "X";
		case key_C:			return "C";
		case key_V:			return "V";
		case key_B:			return "B";
		case key_N:			return "N";
		case key_M:			return "M";
		case key_comma:		return "Less";
		case key_dot:		return "Greater";
		case key_slash:		return "Slash";
		case key_right_shift:	return "Right shift";
		case key_printscreen:	return "Print screen";
		case key_left_alt:		return "Left alt";
		case key_space:		return "Space";
		case key_capslock:	return "Caps lock";
		case key_f1:		return "F1";
		case key_f2:		return "F2";
		case key_f3:		return "F3";
		case key_f4:		return "F4";
		case key_f5:		return "F5";
		case key_f6:		return "F6";
		case key_f7:		return "F7";
		case key_f8:		return "F8";
		case key_f9:		return "F9";
		case key_f10:		return "F10";
		case key_f11:		return "F11";
		case key_f12:		return "F12";
		case key_numlock:	return "Num lock";
		case key_scrolllock:	return "Scroll lock";
		case key_home:		return "Home";
		case key_up:		return "Up";
		case key_pageup:	return "Page up";
		case key_grey_minus:	return "Gray -";
		case key_left:		return "Left";
		case key_numpad_5:	return "Numpad 5";
		case key_right:		return "Right";
		case key_grey_plus:	return "Gray +";
		case key_end:		return "End";
		case key_down:		return "Down";
		case key_pagedown:	return "Page down";
		case key_insert:	return "Insert";
		case key_delete:	return "Delete";
		case key_grey_asterisk:	return "Gray *";
		case key_grey_slash:	return "Gray /";
		case key_pause:			return "Pause";
		case key_right_alt:		return "Right alt";
		case key_right_control:	return "Right control";
		case key_grey_enter:	return "Gray Enter";
		case key_numpad_7:	return "Numpad 7";
		case key_numpad_8:	return "Numpad 8";
		case key_numpad_9:	return "Numpad 9";
		case key_numpad_4:	return "Numpad 4";
		case key_numpad_6:	return "Numpad 6";
		case key_numpad_1:	return "Numpad 1";
		case key_numpad_2:	return "Numpad 2";
		case key_numpad_3:	return "Numpad 3";
		case key_numpad_0:	return "Numpad 0";
		case key_numpad_dot:	return "Numpad .";
		case key_left_win:		return "Left WIN";
		case key_right_win:		return "Right WIN";
		case key_context:		return "Context";
		case key_left_mouse:	return "Left mouse";
		case key_middle_mouse:	return "Middle mouse";
		case key_right_mouse:	return "Right mouse";
		case key_unknown:		return "Unknown key code";
		case key_maxcode:
		default:				break;
	}
	return "Invalid key code";
}

/*
 *	Returns keycode by name.
 */
keycode_t	V_GLOBAL
keycodeGetCode(char *name)
{
	int i;
	if(!name || !name[0])
	{
#ifdef	CHECKED_BUILD
		conlPrintf(LOG_ERROR,"keycodeGetCode('%s'): incorrect parameter.\n",
			dbs(name));
#endif	/* CHECKED_BUILD */
		return key_unknown;
	}
	for(i=0;i<256;i++)
		if(!strcmp(name,keycodeGetName((keycode_t)i)))
			return (keycode_t)i;
	return key_unknown;
}

/*
 *	Returns character for given keycode
 */
char V_GLOBAL
keycodeGetChar(keycode_t key,vboolean lowcase,unsigned char *ext)
{
	unsigned char ext_code;
	if(!ext)
		ext=&ext_code;
	switch(key)
	{
		case key_escape:	return (char)27;
		case key_1:			return (char)((lowcase) ? '1' : '!');
		case key_2:			return (char)((lowcase) ? '2' : '@');
		case key_3:			return (char)((lowcase) ? '3' : '#');
		case key_4:			return (char)((lowcase) ? '4' : '$');
		case key_5:			return (char)((lowcase) ? '5' : '%');
		case key_6:			return (char)((lowcase) ? '6' : '^');
		case key_7:			return (char)((lowcase) ? '7' : '&');
		case key_8:			return (char)((lowcase) ? '8' : '*');
		case key_9:			return (char)((lowcase) ? '9' : '(');
		case key_0:			return (char)((lowcase) ? '0' : ')');
		case key_minus:		return (char)((lowcase) ? '-' : '_');
		case key_equal:		return (char)((lowcase) ? '=' : '+');
		case key_backspace:	return (char)8;
		case key_tab:		return (char)9;
		case key_Q:			return (char)((lowcase) ? 'q' : 'Q');
		case key_W:			return (char)((lowcase) ? 'w' : 'W');
		case key_E:			return (char)((lowcase) ? 'e' : 'E');
		case key_R:			return (char)((lowcase) ? 'r' : 'R');
		case key_T:			return (char)((lowcase) ? 't' : 'T');
		case key_Y:			return (char)((lowcase) ? 'y' : 'Y');
		case key_U:			return (char)((lowcase) ? 'u' : 'U');
		case key_I:			return (char)((lowcase) ? 'i' : 'I');
		case key_O:			return (char)((lowcase) ? 'o' : 'O');
		case key_P:			return (char)((lowcase) ? 'p' : 'P');
		case key_left_bracket:	return (char)((lowcase) ? '[' : '{');
		case key_right_bracket:	return (char)((lowcase) ? ']' : '}');
		case key_enter:		return (char)13;
		case key_left_control:	return (char)0;
		case key_A:			return (char)((lowcase) ? 'a' : 'A');
		case key_S:			return (char)((lowcase) ? 's' : 'S');
		case key_D:			return (char)((lowcase) ? 'd' : 'D');
		case key_F:			return (char)((lowcase) ? 'f' : 'F');
		case key_G:			return (char)((lowcase) ? 'g' : 'G');
		case key_H:			return (char)((lowcase) ? 'h' : 'H');
		case key_J:			return (char)((lowcase) ? 'j' : 'J');
		case key_K:			return (char)((lowcase) ? 'k' : 'K');
		case key_L:			return (char)((lowcase) ? 'l' : 'L');
		case key_colon:		return (char)((lowcase) ? ';' : ':');
		case key_apostrophe:	return (char)((lowcase) ? '\'' : '"');
		case key_back_quote:	return (char)((lowcase) ? '`' : '~');
		case key_left_shift:	return (char)0;
		case key_back_slash:	return (char)((lowcase) ? '\\' : '|');
		case key_Z:			return (char)((lowcase) ? 'z' : 'Z');
		case key_X:			return (char)((lowcase) ? 'x' : 'X');
		case key_C:			return (char)((lowcase) ? 'c' : 'C');
		case key_V:			return (char)((lowcase) ? 'v' : 'V');
		case key_B:			return (char)((lowcase) ? 'b' : 'B');
		case key_N:			return (char)((lowcase) ? 'n' : 'N');
		case key_M:			return (char)((lowcase) ? 'm' : 'M');
		case key_comma:		return (char)((lowcase) ? ',' : '<');
		case key_dot:		return (char)((lowcase) ? '.' : '>');
		case key_slash:		return (char)((lowcase) ? '/' : '?');
		case key_right_shift:	return (char)0;
		case key_printscreen:	return (char)0;
		case key_left_alt:		return (char)0;
		case key_space:		return (char)32;
		case key_capslock:	return (char)0;
		case key_f1:		*ext=59; return (char)0;
		case key_f2:		*ext=60; return (char)0;
		case key_f3:		*ext=61; return (char)0;
		case key_f4:		*ext=62; return (char)0;
		case key_f5:		*ext=63; return (char)0;
		case key_f6:		*ext=64; return (char)0;
		case key_f7:		*ext=65; return (char)0;
		case key_f8:		*ext=66; return (char)0;
		case key_f9:		*ext=67; return (char)0;
		case key_f10:		*ext=68; return (char)0;
		case key_f11:		*ext=133; return (char)0;
		case key_f12:		*ext=134; return (char)0;
		case key_numlock:	return (char)0;
		case key_scrolllock:	return (char)0;
		case key_home:		*ext=71; return (char)0;
		case key_up:		*ext=72; return (char)0;
		case key_pageup:	*ext=73; return (char)0;
		case key_grey_minus:	return (char)'-';
		case key_left:		*ext=75; return (char)0;
		case key_numpad_5:	return (char)0;
		case key_right:		*ext=77; return (char)0;
		case key_grey_plus:	return (char)'+';
		case key_end:		*ext=79; return (char)0;
		case key_down:		*ext=80; return (char)0;
		case key_pagedown:	*ext=81; return (char)0;
		case key_insert:	*ext=82; return (char)0;
		case key_delete:	*ext=83; return (char)0;
		case key_grey_asterisk:	return (char)42;
		case key_grey_slash:	return (char)47;
		case key_pause:			return (char)0;
		case key_right_control:	return (char)0;
		case key_right_alt:		return (char)0;
		case key_grey_enter:	return (char)13;
		case key_numpad_7:		return (char)'7';
		case key_numpad_8:		return (char)'8';
		case key_numpad_9:		return (char)'9';
		case key_numpad_4:		return (char)'4';
		case key_numpad_6:		return (char)'6';
		case key_numpad_1:		return (char)'1';
		case key_numpad_2:		return (char)'2';
		case key_numpad_3:		return (char)'3';
		case key_numpad_0:		return (char)'0';
		case key_numpad_dot:	return (char)'.';
		case key_left_win:		return (char)0;
		case key_right_win:		return (char)0;
		case key_context:		return (char)0;
		case key_left_mouse:	return (char)0;
		case key_middle_mouse:	return (char)0;
		case key_right_mouse:	return (char)0;
		case key_unknown:		return (char)0;
		case key_maxcode:		return (char)0;
	}
	return 0;
}

/*</pre></strong></body></html>*/
/*EOF*/
