/*<html><body bgcolor=#000080><font color=#C0C0B0><strong><pre>*/
#include	<v_lib.h>
#include	<../source/v_mt.h>
#include	<../source/v_os.h>

#ifndef		RIGHT_SLASHED

file_apis_t	unix_file_apis=
{
	lfsEnumFiles,
    vfsSplitPath,
    vfsMakePath,
    uvfsReplaceExt,
    ufileOpenRead,
    ufileOpenWrite,
    ufileOpenAppend
};

file_apis_t	native_file_apis=
{
	lfsEnumFiles,
    nvfsSplitPath,
    nvfsMakePath,
    nvfsReplaceExt,
    nfileOpenRead,
    nfileOpenWrite,
    nfileOpenAppend
};

file_apis_t	*unix_apis_ptr=&unix_file_apis;
file_apis_t	*native_apis_ptr=&native_file_apis;

#endif		/* RIGHT_SLASHED */

/*
 *	See definitions in "v_mt.h"
 */
global_data_t		libv_global_data=
{
	LIBV_GLOBAL_MAGIC,	/* magic */
	0,					/* number of successful calls to threadCreate() */
	NULL,				/* log_file */
	LOG_ERROR,			/* log_upper_level */
#ifdef			NT_CONSOLE
	INVALID_HANDLE_VALUE,	/* input handle */
	INVALID_HANDLE_VALUE,	/* output handle */
	FALSE,					/* console AllocConsole()'d */
#endif			/* NT_CONSOLE */
	TYPED_STACK_EMPTY_INITIALIZER	/* log callbacks */
};

thread_data_t		libv_thread_data=
{
	LIBV_TSD_MAGIC,		/* magic */
	0xFF,				/* constant_alpha - opaque */
	1000,1000,			/* metafile extents */
#ifndef		RIGHT_SLASHED
	&unix_file_apis /* file IO & FS-processing routines */
#endif		/* RIGHT_SLASHED */
	/* All other members must be 0/NULL */
};

void	V_GLOBAL
memFree(void *block)
{
	free(block);
}

void_p	V_GLOBAL
memAlloc(u32_t size)
{
	return malloc(size);
}

void_p	V_GLOBAL
memRealloc(void *block,u32_t newsize)
{
	return realloc(block,newsize);
}

#ifdef		__WIN32__
void		V_CALL
libvError(char *msg)
{
	MessageBoxA(NULL,msg,"LibV",MB_OK|MB_ICONHAND);
}

V_LOCAL		int	detected_must_die=-1;

vboolean	V_CALL
WeAreUnderMustDie(void)
{
	if(detected_must_die==-1)
	{
		OSVERSIONINFO vi;
		memZero(&vi,sizeof(OSVERSIONINFO));
		vi.dwOSVersionInfoSize=sizeof(OSVERSIONINFO);
		GetVersionEx(&vi);
		if(vi.dwPlatformId == VER_PLATFORM_WIN32_NT)
			detected_must_die=(int)false;
		else
			detected_must_die=(int)true;
	}
	return (vboolean)detected_must_die;
}

#elif		defined(__UNIX__) /* !__WIN32__ */

void		V_CALL
libvError(char *msg)
{
	fprintf(stderr,"LibV error: %s.\n",msg);
}

#endif		/* __WIN32__ */

#if		defined(BUILD_DLL) && defined(__WIN32__)

#include <../source/argsused.h>
BOOL WINAPI
DllMain(HINSTANCE hInstance,DWORD fdwReason,LPVOID lpvReserved)
{
	/* Nothing to do */
	switch(fdwReason)
	{
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
	}
	return TRUE;
}

#endif	/* BUILD_DLL && __WIN32__ */

/*
**	Platform - independent utility functions.
*/
#ifdef	CHECKED_BUILD
void_p	V_CALL
libvIsHandle(void *handle,char *caller,char *object,u32_t magic)
{
	if(!handle)
	{
		conlPrintf(LOG_ERROR,"%s(): NULL descriptor.\n",caller);
		return NULL;
	}
	if(*((u32_t*)handle) != magic)
	{
		conlPrintf(LOG_ERROR,"%s(): %s damaged: bad magic.\n",caller,
			object ? object : "object");
		return NULL;
	}
	return handle;
}
#endif	/* CHECKED_BUILD */

/*</pre></strong></body></html>*/
/*EOF*/
